package ats;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;

import salsa.language.UniversalActor;

import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.

import theater.IOTheater;
import core.agents.ProfilingAgent;
import java.util.Vector;
import salsa.language.ServiceFactory;
import salsa.messaging.TheaterService;
import salsa.naming.NamingService;
import salsa.naming.UAL;
import salsa.naming.UAN;

public class ATSDecisionActor extends UniversalActor  {
	public static void main(String args[]) {
		UAN uan = null;
		UAL ual = null;
		if (System.getProperty("uan") != null) {
			uan = new UAN( System.getProperty("uan") );
			ServiceFactory.getTheater();
			RunTime.receivedUniversalActor();
		}
		if (System.getProperty("ual") != null) {
			ual = new UAL( System.getProperty("ual") );

			if (uan == null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an actor to have a ual at runtime without a uan.");
				System.err.println("	To give an actor a specific ual at runtime, use the identifier system property.");
				System.exit(0);
			}
			RunTime.receivedUniversalActor();
		}
		if (System.getProperty("identifier") != null) {
			if (ual != null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an identifier and a ual with system properties when creating an actor.");
				System.exit(0);
			}
			ual = new UAL( ServiceFactory.getTheater().getLocation() + System.getProperty("identifier"));
		}
		ATSDecisionActor instance = (ATSDecisionActor)new ATSDecisionActor(uan, ual).construct();
		{
			Object[] _arguments = { args };
			instance.send( new Message(instance, instance, "act", _arguments, null, null) );
		}
	}

	public static ActorReference getReferenceByName(UAN uan)	{ return new ATSDecisionActor(false, uan); }
	public static ActorReference getReferenceByName(String uan)	{ return ATSDecisionActor.getReferenceByName(new UAN(uan)); }
	public static ActorReference getReferenceByLocation(UAL ual)	{ return new ATSDecisionActor(false, ual); }

	public static ActorReference getReferenceByLocation(String ual)	{ return ATSDecisionActor.getReferenceByLocation(new UAL(ual)); }
	public ATSDecisionActor(boolean o, UAN __uan)	{ super(__uan); }
	public ATSDecisionActor(boolean o, UAL __ual)	{ super(__ual); }

	public ATSDecisionActor(UAN __uan)	{ this(__uan, null); }
	public ATSDecisionActor(UAL __ual)	{ this(null, __ual); }
	public ATSDecisionActor()		{ this(null, null);  }
	public ATSDecisionActor(UAN __uan, UAL __ual) {
		if (__ual != null && !__ual.getLocation().equals(ServiceFactory.getTheater().getLocation())) {
			createRemotely(__uan, __ual, "ats.ATSDecisionActor");
		} else {
			State state = new State(__uan, __ual);
			state.updateSelf(this);
			ServiceFactory.getNaming().setEntry(state.getUAN(), state.getUAL(), state);
			if (getUAN() != null) ServiceFactory.getNaming().update(state.getUAN(), state.getUAL());
		}
	}

	public UniversalActor construct () {
		Object[] __arguments = {  };
		this.send( new Message(this, this, "construct", __arguments, null, null) );
		return this;
	}

	public class State extends UniversalActor.State {
		public ATSDecisionActor self;
		public void updateSelf(ActorReference actorReference) {
			self = (ATSDecisionActor)actorReference;
			self.setUAN(getUAN());
			self.setUAL(getUAL());
		}

		public State() {
			this(null, null);
		}

		public State(UAN __uan, UAL __ual) {
			super(__uan, __ual);
			addClassName( "ats.ATSDecisionActor$State" );
			addMethodsForClasses();
		}

		public void process(Message message) {
			Method[] matches = getMatches(message.getMethodName());
			Object returnValue = null;
			Exception exception = null;

			if (matches != null) {
				for (int i = 0; i < matches.length; i++) {
					try {
						if (matches[i].getParameterTypes().length != message.getArguments().length) continue;
						returnValue = matches[i].invoke(this, message.getArguments());
					} catch (Exception e) {
						if (e.getCause() instanceof CurrentContinuationException) {
							sendGeneratedMessages();
							return;
						} else if (e instanceof InvocationTargetException) {
							sendGeneratedMessages();
							exception = (Exception)e.getCause();
							break;
						} else {
							continue;
						}
					}
					sendGeneratedMessages();
					currentMessage.resolveContinuations(returnValue);
					return;
				}
			}

			System.err.println("Message processing exception:");
			if (message.getSource() != null) {
				System.err.println("\tSent by: " + message.getSource().toString());
			} else System.err.println("\tSent by: unknown");
			System.err.println("\tReceived by actor: " + toString());
			System.err.println("\tMessage: " + message.toString());
			if (exception == null) {
				if (matches == null) {
					System.err.println("\tNo methods with the same name found.");
					return;
				}
				System.err.println("\tDid not match any of the following: ");
				for (int i = 0; i < matches.length; i++) {
					System.err.print("\t\tMethod: " + matches[i].getName() + "( ");
					Class[] parTypes = matches[i].getParameterTypes();
					for (int j = 0; j < parTypes.length; j++) {
						System.err.print(parTypes[j].getName() + " ");
					}
					System.err.println(")");
				}
			} else {
				System.err.println("\tThrew exception: " + exception);
				exception.printStackTrace();
			}
		}

		ATSProfilingAgent profilingAgent = null;
		ActorReference protocolActor = null;
		int sleepTime = 10000;
		long throughput = 0;
		void construct(){
			protocolActor = IOTheater.getProtocolActor();
			profilingAgent = (ATSProfilingAgent)IOTheater.getProfilingAgent();
						{
				// begin()
				{
					Object _arguments[] = {  };
					Message message = new Message( self, self, "begin", _arguments, null, null );
					__messages.add( message );
				}
			}
		}
		public void begin() {
			if (System.getProperty("silent")==null) {
				{
					// standardOutput<-println("\n\n"+System.currentTimeMillis()+"\t"+profilingAgent.processed()+"\t\t"+profilingAgent.getActorProfiles().size()+"\t"+profilingAgent.getAvailableProcessing()+"\n")
					{
						Object _arguments[] = { "\n\n"+System.currentTimeMillis()+"\t"+profilingAgent.processed()+"\t\t"+profilingAgent.getActorProfiles().size()+"\t"+profilingAgent.getAvailableProcessing()+"\n" };
						Message message = new Message( self, standardOutput, "println", _arguments, null, null );
						__messages.add( message );
					}
				}
			}
			throughput = profilingAgent.processed();
			if (!profilingAgent.isComputing()) 			{
				// protocolActor<-leaveComputation()
				{
					Object _arguments[] = {  };
					Message message = new Message( self, protocolActor, "leaveComputation", _arguments, null, null );
					__messages.add( message );
				}
			}
			if (profilingAgent.isLight()&&profilingAgent.isComputing()) {
				{
					// protocolActor<-initiateSteal()
					{
						Object _arguments[] = {  };
						Message message = new Message( self, protocolActor, "initiateSteal", _arguments, null, null );
						__messages.add( message );
					}
				}
			}
			profilingAgent.reset();
			{
				// ()begin:((new Integer(sleepTime)))
				{
					Object _arguments[] = {  };
					Message message = new Message( self, self, "begin", _arguments, null, null );
					Object[] _propertyInfo = { new Integer(sleepTime) };
					message.setProperty( "delay", _propertyInfo );
					__messages.add( message );
				}
			}
		}
		private double decisionFunction(ActorProfile candidate, UAL source, double remoteFLOPS) {
			String localId = protocolActor.getUAL().getLocation().toString();
			String foreignId = source.getLocation();
			if (profilingAgent.timeSinceLastReset()==0) 			return 0;
			double msPerMessageLocal = candidate.processed()/profilingAgent.timeSinceLastReset();
			if (candidate.processed()==0) 			return 0;
			double avgFLOPSPerMessage = profilingAgent.getFLOPSUsedBy(candidate)/candidate.processed();
			long foreignSendEstimation = candidate.sent()-candidate.sentTo(foreignId);
			if (foreignSendEstimation==0) foreignSendEstimation = 1;
			if (remoteFLOPS==0) 			return 0;
			double msPerMessageRemote = (avgFLOPSPerMessage/remoteFLOPS)+(candidate.timeSending()/foreignSendEstimation);
			return msPerMessageRemote-msPerMessageLocal;
		}
		public ActorReference getBestCandidate(UAL source, double remoteProcessing) {
			ActorProfile candidate = null;
			double candidateGain = 0;
			if (!profilingAgent.isComputing()) 			return null;
			System.out.println("Trying to get the best candidate");
			Vector actorProfiles = profilingAgent.getActorProfiles();
			System.out.println("Actors size :"+actorProfiles.size());
			for (int i = 0; i<actorProfiles.size(); i++){
				System.out.println("Inside the for loop");
				ActorProfile current = (ActorProfile)actorProfiles.get(i);
				if (!current.getScheduled()) {
					double gain = decisionFunction(current, source, remoteProcessing);
					System.out.println("\tATS GAIN: "+gain);
					if (gain>candidateGain) {
						candidate = current;
						candidateGain = gain;
					}
				}
				else {
					System.out.println("scheduled");
				}
			}
			if (candidate!=null) {
				candidate.setScheduled(true);
				return new UniversalActor(candidate.getUAN());
			}
			return null;
		}
		public Long getThroughput() {
			return new Long(throughput);
		}
	}
}