package core.agents;

import salsa.language.Message;
import salsa.naming.UAN;

public interface ProfilingAgent {
	//The following methods notifiy the profiling agent of
	//actors entering and exiting the theater due to 
	//migration and binding
	public void addProfile(UAN uan);
	public void removeProfile(UAN uan);

	//The profiling agent updates its actor profiles based on
	//message sending with these methods
	public void beginSend(UAN uan, Message message);
	public void endSend(UAN uan, Message message);

	//The profiling agent updates its actor profiles based on
	//message reception with this method
	public void received(UAN uan, Message message);

	//The following methods notify the profiling agent of
	//the start of a message being processed and the end
	//of a message being processed, with a UAN or UAL to
	//identify the sending actor
	public void beginProcessed(UAN uan, Message message);
	public void endProcessed(UAN uan, Message message);
}
