package ntsC2C;

import ntsC2C.core.agents.ProfilingAgent;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.ServiceFactory;
import salsa.language.exceptions.SalsaWrapperException;
import wwc.messaging.Theater;

public class IOTheater extends Theater {
	static ActorReference decisionActor = null;
	static ActorReference protocolActor = null;
	static ProfilingAgent profilingAgent = null;


	public static synchronized ActorReference getProtocolActor() {
			if (protocolActor == null) {
				//Check for the protocol actor
				//default = io.ats.ATSProtocolActor
				String className = System.getProperty( "protocol" );  
				if (className == null) className = "ntsC2C.pslb.PSLBProtocolActor";

				try {
					protocolActor = ServiceFactory.createActor(className, "io/protocolActor");
				} catch (Exception e) {
					System.err.println("Error creating protocol actor: " + className);
					System.err.println("\t" + e);
					e.printStackTrace();
				}
				
				//start the protocol actor
				Object _arguments[] = {new Integer(0)};
				Message message = new Message(null, protocolActor, "begin", _arguments, null, null);
				protocolActor.send(message);
			}
			return protocolActor;
		}

		public static synchronized ActorReference getDecisionActor() {
			if (decisionActor == null) {
				//Check for the decision actor
				//default = io.ats.ATSDecisionActor
				String className = System.getProperty( "decision" );  
				if (className == null) className = "ntsC2C.pslb.PSLBDecisionActor";

				try {
					decisionActor = ServiceFactory.createActor(className, "io/decisionActor");
				} catch (Exception e) {
					System.err.println("Error creating decision actor: " + className);
					System.err.println("\t" + e);
					e.printStackTrace();
				}
			}
			return decisionActor;
		}



	public static synchronized ProfilingAgent getProfilingAgent() {
		if (profilingAgent == null) {
			//Check for the profiling agent
			//default = io.ats.ATSProfilingAgent
			String className = System.getProperty( "profiling" );  
			if (className == null) className = "ntsC2C.pslb.PSLBProfilingAgent";

			try {
				profilingAgent = (ProfilingAgent)Class.forName( className ).newInstance();
			} catch (Exception e) {
				throw new SalsaWrapperException( "Exception creating the IO profiling agent.", e );
			}
		}
		return profilingAgent;
	}

	public IOTheater() {
		String[] args = { "0" };
                Theater.main(args);

		getProfilingAgent();
		//getDecisionActor();
		getProtocolActor();
	}

	public static void main(String[] arguments) {
		Theater.main(arguments);

		getProfilingAgent();
		//getDecisionActor();
		getProtocolActor();
	}
}
