package ntsC2C.peerserver;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;

import salsa.language.UniversalActor;

import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.

import java.util.*;
import java.lang.Thread;
import ntsC2C.pslb.PSLBProtocolActor;
import ntsC2C.pslb.PSLBProfilingAgent;
import ntsC2C.IOTheater;
import salsa.naming.UAL;

public class PeerServer extends UniversalActor  {
	public static void main(String args[]) {
		UAN uan = null;
		UAL ual = null;
		if (System.getProperty("uan") != null) {
			uan = new UAN( System.getProperty("uan") );
			ServiceFactory.getTheater();
			RunTime.receivedUniversalActor();
		}
		if (System.getProperty("ual") != null) {
			ual = new UAL( System.getProperty("ual") );

			if (uan == null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an actor to have a ual at runtime without a uan.");
				System.err.println("	To give an actor a specific ual at runtime, use the identifier system property.");
				System.exit(0);
			}
			RunTime.receivedUniversalActor();
		}
		if (System.getProperty("identifier") != null) {
			if (ual != null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an identifier and a ual with system properties when creating an actor.");
				System.exit(0);
			}
			ual = new UAL( ServiceFactory.getTheater().getLocation() + System.getProperty("identifier"));
		}
		PeerServer instance = (PeerServer)new PeerServer(uan, ual).construct();
		{
			Object[] _arguments = { args };
			instance.send( new Message(instance, instance, "act", _arguments, null, null) );
		}
	}

	public static ActorReference getReferenceByName(UAN uan)	{ return new PeerServer(false, uan); }
	public static ActorReference getReferenceByName(String uan)	{ return PeerServer.getReferenceByName(new UAN(uan)); }
	public static ActorReference getReferenceByLocation(UAL ual)	{ return new PeerServer(false, ual); }

	public static ActorReference getReferenceByLocation(String ual)	{ return PeerServer.getReferenceByLocation(new UAL(ual)); }
	public PeerServer(boolean o, UAN __uan)	{ super(__uan); }
	public PeerServer(boolean o, UAL __ual)	{ super(__ual); }

	public PeerServer(UAN __uan)	{ this(__uan, null); }
	public PeerServer(UAL __ual)	{ this(null, __ual); }
	public PeerServer()		{ this(null, null);  }
	public PeerServer(UAN __uan, UAL __ual) {
		if (__ual != null && !__ual.getLocation().equals(ServiceFactory.getTheater().getLocation())) {
			createRemotely(__uan, __ual, "ntsC2C.peerserver.PeerServer");
		} else {
			State state = new State(__uan, __ual);
			state.updateSelf(this);
			ServiceFactory.getNaming().setEntry(state.getUAN(), state.getUAL(), state);
			if (getUAN() != null) ServiceFactory.getNaming().update(state.getUAN(), state.getUAL());
		}
	}

	public UniversalActor construct () {
		Object[] __arguments = {  };
		this.send( new Message(this, this, "construct", __arguments, null, null) );
		return this;
	}

	public class State extends UniversalActor.State {
		public PeerServer self;
		public void updateSelf(ActorReference actorReference) {
			self = (PeerServer)actorReference;
			self.setUAN(getUAN());
			self.setUAL(getUAL());
		}

		public State() {
			this(null, null);
		}

		public State(UAN __uan, UAL __ual) {
			super(__uan, __ual);
			addClassName( "ntsC2C.peerserver.PeerServer$State" );
			addMethodsForClasses();
		}

		public void process(Message message) {
			Method[] matches = getMatches(message.getMethodName());
			Object returnValue = null;
			Exception exception = null;

			if (matches != null) {
				for (int i = 0; i < matches.length; i++) {
					try {
						if (matches[i].getParameterTypes().length != message.getArguments().length) continue;
						returnValue = matches[i].invoke(this, message.getArguments());
					} catch (Exception e) {
						if (e.getCause() instanceof CurrentContinuationException) {
							sendGeneratedMessages();
							return;
						} else if (e instanceof InvocationTargetException) {
							sendGeneratedMessages();
							exception = (Exception)e.getCause();
							break;
						} else {
							continue;
						}
					}
					sendGeneratedMessages();
					currentMessage.resolveContinuations(returnValue);
					return;
				}
			}

			System.err.println("Message processing exception:");
			if (message.getSource() != null) {
				System.err.println("\tSent by: " + message.getSource().toString());
			} else System.err.println("\tSent by: unknown");
			System.err.println("\tReceived by actor: " + toString());
			System.err.println("\tMessage: " + message.toString());
			if (exception == null) {
				if (matches == null) {
					System.err.println("\tNo methods with the same name found.");
					return;
				}
				System.err.println("\tDid not match any of the following: ");
				for (int i = 0; i < matches.length; i++) {
					System.err.print("\t\tMethod: " + matches[i].getName() + "( ");
					Class[] parTypes = matches[i].getParameterTypes();
					for (int j = 0; j < parTypes.length; j++) {
						System.err.print(parTypes[j].getName() + " ");
					}
					System.err.println(")");
				}
			} else {
				System.err.println("\tThrew exception: " + exception);
				exception.printStackTrace();
			}
		}

		PSLBProfilingAgent profilingAgent = (PSLBProfilingAgent)IOTheater.getProfilingAgent();
		Hashtable peerProfiles = new Hashtable();
		Vector peerManagers = new Vector();
		Hashtable theaterProfiles = new Hashtable();
		Vector theaters = new Vector();
		int sleepTime = 10000;
		int peerBalanceSleepTime = 50000;
		int totalLoad = 0;
		int avgLoad = 0;
		double stDeviation = 0.0;
		int threshold = 2;
		int lightLoad = 5;
		int highLoad = 10;
		int peerLoadThreshold = 10;
		long totalCpu = -1;
		long avgCpu = -1;
		long lightCpuLoad = 10;
		int cpuThreshold = 3;
		ActorReference lightestTheater = null;
		void construct(){
			salsa.language.RunTime.receivedUniversalActor();
		}
		public void act(String[] args) {
			{
				// standardOutput<-println("peerServer listening at UAL: "+getUAL())
				{
					Object _arguments[] = { "peerServer listening at UAL: "+getUAL() };
					Message message = new Message( self, standardOutput, "println", _arguments, null, null );
					__messages.add( message );
				}
			}
			{
				// balance()
				{
					Object _arguments[] = {  };
					Message message = new Message( self, self, "balance", _arguments, null, null );
					__messages.add( message );
				}
			}
			{
				Token token_2_0 = new Token();
				// meetPeers(args)
				{
					Object _arguments[] = { args };
					Message message = new Message( self, self, "meetPeers", _arguments, null, token_2_0 );
					__messages.add( message );
				}
				// peerBalance_ActorBased()
				{
					Object _arguments[] = {  };
					Message message = new Message( self, self, "peerBalance_ActorBased", _arguments, token_2_0, null );
					__messages.add( message );
				}
			}
		}
		public void balance() {
			{
				Token token_2_0 = new Token();
				Token token_2_1 = new Token();
				// updateProfiles()
				{
					Object _arguments[] = {  };
					Message message = new Message( self, self, "updateProfiles", _arguments, null, token_2_0 );
					__messages.add( message );
				}
				// balanceTheatersCPU_Based()
				{
					Object _arguments[] = {  };
					Message message = new Message( self, self, "balanceTheatersCPU_Based", _arguments, token_2_0, token_2_1 );
					__messages.add( message );
				}
				// ()balance:((new Integer(sleepTime)))
				{
					Object _arguments[] = {  };
					Message message = new Message( self, self, "balance", _arguments, token_2_1, null );
					Object[] _propertyInfo = { new Integer(sleepTime) };
					message.setProperty( "delay", _propertyInfo );
					__messages.add( message );
				}
			}
		}
		public void peerBalance_ActorBased() {
			if (theaterProfiles.size()==0) {
				{
					// ()peerBalance_ActorBased:((new Integer(peerBalanceSleepTime)))
					{
						Object _arguments[] = {  };
						Message message = new Message( self, self, "peerBalance_ActorBased", _arguments, null, null );
						Object[] _propertyInfo = { new Integer(peerBalanceSleepTime) };
						message.setProperty( "delay", _propertyInfo );
						__messages.add( message );
					}
				}
				return;
			}
			Collections.sort(peerManagers, new PeerComparator());
			if (avgLoad<=lightLoad) {
				{
					// tryStealing(new Integer(0))
					{
						Object _arguments[] = { new Integer(0) };
						Message message = new Message( self, self, "tryStealing", _arguments, null, null );
						__messages.add( message );
					}
				}
			}
		}
		public void tryStealing(Integer index) {
			if (avgLoad>=lightLoad) {
				{
					// ()peerBalance_ActorBased:((new Integer(peerBalanceSleepTime)))
					{
						Object _arguments[] = {  };
						Message message = new Message( self, self, "peerBalance_ActorBased", _arguments, null, null );
						Object[] _propertyInfo = { new Integer(peerBalanceSleepTime) };
						message.setProperty( "delay", _propertyInfo );
						__messages.add( message );
					}
				}
				return;
			}
			if (index.intValue()<peerManagers.size()) {
				ActorReference pServer = ((PeerProfile)peerManagers.get(index.intValue())).getReference();
				TheaterProfile tp = getFastestTheater();
				{
					Token token_3_0 = new Token();
					// pServer<-stealWork_ActorBased(((PeerServer)self), new Integer(totalLoad), tp)
					{
						Object _arguments[] = { ((PeerServer)self), new Integer(totalLoad), tp };
						Message message = new Message( self, pServer, "stealWork_ActorBased", _arguments, null, token_3_0 );
						__messages.add( message );
					}
					// resolveSteal(token, pServer, new Integer(index.intValue()+1))
					{
						Object _arguments[] = { token_3_0, pServer, new Integer(index.intValue()+1) };
						Message message = new Message( self, self, "resolveSteal", _arguments, token_3_0, null );
						__messages.add( message );
					}
				}
			}
			else {
				{
					// ()peerBalance_ActorBased:((new Integer(peerBalanceSleepTime)))
					{
						Object _arguments[] = {  };
						Message message = new Message( self, self, "peerBalance_ActorBased", _arguments, null, null );
						Object[] _propertyInfo = { new Integer(peerBalanceSleepTime) };
						message.setProperty( "delay", _propertyInfo );
						__messages.add( message );
					}
				}
				return;
			}
		}
		public void resolveSteal(Boolean reply, PeerServer pServer, Integer index) {
			if (!reply.booleanValue()) 			{
				// tryStealing(index)
				{
					Object _arguments[] = { index };
					Message message = new Message( self, self, "tryStealing", _arguments, null, null );
					__messages.add( message );
				}
			}
			else {
				{
					// ()peerBalance_ActorBased:((new Integer(peerBalanceSleepTime)))
					{
						Object _arguments[] = {  };
						Message message = new Message( self, self, "peerBalance_ActorBased", _arguments, null, null );
						Object[] _propertyInfo = { new Integer(peerBalanceSleepTime) };
						message.setProperty( "delay", _propertyInfo );
						__messages.add( message );
					}
				}
			}
		}
		public Boolean stealWork_ActorBased(PeerServer stealer, Integer myLoad, TheaterProfile targetTP) {
			if ((totalLoad-myLoad.intValue())>=peerLoadThreshold) {
				TheaterProfile sourceTP = getHeaviestTheater();
				if (sourceTP!=null) {
					String key = sourceTP.getMyUAL().toString();
					Token recentTp = new Token("recentTp");
					{
						// token recentTp = (sourceTP.getProtocolActor())<-getRecentProfile()
						{
							Object _arguments[] = {  };
							Message message = new Message( self, (sourceTP.getProtocolActor()), "getRecentProfile", _arguments, null, recentTp );
							Object[] _propertyInfo = {  };
							message.setProperty( "priority", _propertyInfo );
							__messages.add( message );
						}
					}
					{
						Token token_4_0 = new Token();
						// updateProfile(recentTp)
						{
							Object _arguments[] = { recentTp };
							Message message = new Message( self, self, "updateProfile", _arguments, null, token_4_0 );
							__messages.add( message );
						}
						// waitForSynch(token)
						{
							Object _arguments[] = { token_4_0 };
							Message message = new Message( self, self, "waitForSynch", _arguments, token_4_0, null );
							__messages.add( message );
						}
					}
					sourceTP = (TheaterProfile)theaterProfiles.get(key);
					int loadS = sourceTP.getLoad();
					int loadT = targetTP.getLoad();
					int total = loadS+loadT;
					long cpuS = sourceTP.getCpuUsage();
					long cpuT = targetTP.getCpuUsage();
					int loadThreshold = (int)((double)(cpuT*total)/(double)(cpuT+cpuS));
					if (loadS>loadThreshold&&Math.abs(loadS-loadT)>2) {
						int toTransfer = loadS-loadThreshold;
						if (toTransfer>5) toTransfer = 5;
						ActorReference target = targetTP.getProtocolActor();
						ActorReference source = sourceTP.getProtocolActor();
						{
							Token token_5_0 = new Token();
							// source<-transferLoad((PSLBProtocolActor)target, new Integer(toTransfer), new Integer(loadS))
							{
								Object _arguments[] = { (PSLBProtocolActor)target, new Integer(toTransfer), new Integer(loadS) };
								Message message = new Message( self, source, "transferLoad", _arguments, null, token_5_0 );
								Object[] _propertyInfo = {  };
								message.setProperty( "priority", _propertyInfo );
								__messages.add( message );
							}
							// waitForSynch(token)
							{
								Object _arguments[] = { token_5_0 };
								Message message = new Message( self, self, "waitForSynch", _arguments, token_5_0, null );
								__messages.add( message );
							}
						}
						return new Boolean(true);
					}
				}
			}
			return new Boolean(false);
		}
		public PeerServer createPeerProfile(UAL peerUAL) {
			PeerProfile peerProfile = new PeerProfile(peerUAL);
			if (peerManagers.contains(peerProfile)) 			return null;
			UAL sensorUAL = new UAL("rmsp://"+peerUAL.getHost()+":"+peerUAL.getPort()+"/io/delaySensor");
			long rttDelay = profilingAgent.getPeerDelay(sensorUAL.getHost());
			PeerServer pServer = (PeerServer)PeerServer.getReferenceByLocation(peerUAL);
			peerProfile.setDelay(rttDelay);
			peerProfile.setReference(pServer);
			peerManagers.add(peerProfile);
			{
				// pServer<-introducePeer(((PeerServer)self), new Long(rttDelay))
				{
					Object _arguments[] = { ((PeerServer)self), new Long(rttDelay) };
					Message message = new Message( self, pServer, "introducePeer", _arguments, null, null );
					__messages.add( message );
				}
			}
			return pServer;
		}
		public void meetPeers(String[] ids) {
			if (ids.length!=0) {
				{
					Token token_3_0 = new Token();
					// join block
					token_3_0.setJoinDirector();
					for (int i = 0; i<ids.length; i++){
						UAL peerUAL = new UAL(ids[i]+"io/peerServer");
						{
							// createPeerProfile(peerUAL)
							{
								Object _arguments[] = { peerUAL };
								Message message = new Message( self, self, "createPeerProfile", _arguments, null, token_3_0 );
								__messages.add( message );
							}
						}
					}
					token_3_0.createJoinDirector();
					// sendPeers(token)
					{
						Object _arguments[] = { token_3_0 };
						Message message = new Message( self, self, "sendPeers", _arguments, token_3_0, null );
						__messages.add( message );
					}
				}
			}
		}
		public void sendPeers(Object[] peers) {
			for (int i = 0; i<peers.length-1; i++)for (int j = i+1; j<peers.length; j++)			{
				// ((PeerServer)peers[i])<-createPeerProfile(((PeerServer)peers[j]).getUAL())
				{
					Object _arguments[] = { ((PeerServer)peers[j]).getUAL() };
					Message message = new Message( self, ((PeerServer)peers[i]), "createPeerProfile", _arguments, null, null );
					__messages.add( message );
				}
			}
		}
		public void introducePeer(PeerServer pServer, Long roundTrip) {
			String peerUAL = pServer.getUAL().toString();
			PeerProfile peerProfile = new PeerProfile(pServer.getUAL());
			if (!peerManagers.contains(peerProfile)) {
				peerProfile.setDelay(roundTrip.longValue());
				peerProfile.setReference(pServer);
				peerManagers.add(peerProfile);
			}
			String pUAL;
			for (int i = 0; i<peerManagers.size(); i++){
				pUAL = ((PeerProfile)peerManagers.get(i)).getUAL().toString();
				if (!pUAL.equals(peerUAL)) {
					{
						// pServer<-createPeerProfile(new UAL(pUAL))
						{
							Object _arguments[] = { new UAL(pUAL) };
							Message message = new Message( self, pServer, "createPeerProfile", _arguments, null, null );
							__messages.add( message );
						}
					}
				}
			}
		}
		public void register(ActorReference peer, TheaterProfile tp) {
			String key = peer.getUAL().toString();
			{
				// standardOutput<-println("Theater "+key+" has joined")
				{
					Object _arguments[] = { "Theater "+key+" has joined" };
					Message message = new Message( self, standardOutput, "println", _arguments, null, null );
					__messages.add( message );
				}
			}
			if (!theaterProfiles.containsKey(key)) {
synchronized (theaterProfiles) {
{
					theaterProfiles.put(peer.getUAL().toString(), tp);
				}
}
			}
			else {
				{
					// standardOutput<-println("Theater already registered")
					{
						Object _arguments[] = { "Theater already registered" };
						Message message = new Message( self, standardOutput, "println", _arguments, null, null );
						__messages.add( message );
					}
				}
			}
		}
		public void register(ActorReference peer, TheaterProfile tp, PeerServer parentServer) {
			this.register(peer, tp);
			TheaterProfile profile = (TheaterProfile)theaterProfiles.get(peer.getUAL().toString());
			if (profile!=null) profile.setLocal(false);
		}
		public void updateProfile(ActorReference peer, Integer numActors, Long cpuUsage, Long freeMemory, Long msgTag) {
			String key = peer.getUAL().toString();
			TheaterProfile theaterProfile = (TheaterProfile)theaterProfiles.get(key);
			if (theaterProfile!=null) {
				if (msgTag.longValue()<=theaterProfile.getTag()) {
					return;
				}
				theaterProfile.setLoad(numActors.intValue());
				theaterProfile.setCpuUsage(cpuUsage.longValue());
				theaterProfile.setFreeMemory(freeMemory.longValue());
				theaterProfile.setTag(msgTag.longValue());
synchronized (theaterProfiles) {
{
					theaterProfiles.put(key, theaterProfile);
				}
}
			}
		}
		public void updateProfiles() {
			if (theaterProfiles.size()!=0) {
				Vector profiles = new Vector();
				Iterator iterEntries = theaterProfiles.entrySet().iterator();
				while (iterEntries.hasNext()) {
					Map.Entry mapEntry = (Map.Entry)iterEntries.next();
					profiles.addElement((TheaterProfile)mapEntry.getValue());
				}
				for (int i = 0; i<profiles.size(); i++){
					TheaterProfile tp = (TheaterProfile)profiles.get(i);
					Token recentTp = new Token("recentTp");
					{
						// token recentTp = (tp.getProtocolActor())<-getRecentProfile()
						{
							Object _arguments[] = {  };
							Message message = new Message( self, (tp.getProtocolActor()), "getRecentProfile", _arguments, null, recentTp );
							Object[] _propertyInfo = {  };
							message.setProperty( "priority", _propertyInfo );
							__messages.add( message );
						}
					}
					{
						Token token_4_0 = new Token();
						// updateProfile(recentTp)
						{
							Object _arguments[] = { recentTp };
							Message message = new Message( self, self, "updateProfile", _arguments, null, token_4_0 );
							__messages.add( message );
						}
						// waitForSynch(token)
						{
							Object _arguments[] = { token_4_0 };
							Message message = new Message( self, self, "waitForSynch", _arguments, token_4_0, null );
							__messages.add( message );
						}
					}
				}
			}
		}
		public void waitForSynch(Boolean sync) {
		}
		public void getProfile(TheaterProfile tp) {
			Token recentTp = new Token("recentTp");
			{
				// token recentTp = (tp.getProtocolActor())<-getRecentProfile()
				{
					Object _arguments[] = {  };
					Message message = new Message( self, (tp.getProtocolActor()), "getRecentProfile", _arguments, null, recentTp );
					Object[] _propertyInfo = {  };
					message.setProperty( "priority", _propertyInfo );
					__messages.add( message );
				}
			}
			{
				// updateProfile(recentTp)
				{
					Object _arguments[] = { recentTp };
					Message message = new Message( self, self, "updateProfile", _arguments, null, null );
					__messages.add( message );
				}
			}
		}
		public Boolean updateProfile(TheaterProfile tp) {
			if (tp==null) 			return new Boolean(true);
			String key = tp.getMyUAL();
			theaterProfiles.put(key, tp);
			return new Boolean(true);
		}
		public void balanceTheatersActors_Based() {
			if (theaterProfiles.size()!=0) {
				Vector profiles = new Vector();
				Iterator iterEntries = theaterProfiles.entrySet().iterator();
				totalLoad = 0;
				while (iterEntries.hasNext()) {
					Map.Entry mapEntry = (Map.Entry)iterEntries.next();
					profiles.addElement((TheaterProfile)mapEntry.getValue());
					totalLoad += ((TheaterProfile)mapEntry.getValue()).getLoad();
				}
				avgLoad = (int)(totalLoad/profiles.size());
				double tmp = 0;
				for (int i = 0; i<profiles.size(); i++)tmp += Math.pow((double)(((TheaterProfile)profiles.get(i)).getLoad()-avgLoad), 2.0);
				stDeviation = Math.sqrt(tmp/profiles.size());
				Collections.sort(profiles, new TheaterComparator_ActorBased());
				lightestTheater = ((TheaterProfile)profiles.get(0)).getProtocolActor();
				TheaterProfile tp;
				for (Enumeration e = profiles.elements(); e.hasMoreElements(); ){
					tp = (TheaterProfile)e.nextElement();
					System.out.println(tp.getProtocolActor().getUAL().toString()+"\t"+tp.getLoad());
				}
				System.out.println("------------------------------");
				int size = profiles.size();
				int j = size-1;
				int i = 0;
				int loadDiff = 0;
				TheaterProfile tpI, tpJ;
				int toTransfer = 0;
				ActorReference target = null;
				ActorReference source = null;
				while (i<j) {
					tpI = (TheaterProfile)profiles.get(i);
					tpJ = (TheaterProfile)profiles.get(j);
					loadDiff = tpI.getLoad()-tpJ.getLoad();
					if (loadDiff>threshold) {
						toTransfer = (tpI.getLoad()+tpJ.getLoad())/2-tpJ.getLoad();
						target = tpJ.getProtocolActor();
						source = tpI.getProtocolActor();
						if (toTransfer>5) toTransfer = 5;
						{
							Token token_5_0 = new Token();
							// source<-transferLoad((PSLBProtocolActor)target, new Integer(toTransfer), new Integer(tpI.getLoad()))
							{
								Object _arguments[] = { (PSLBProtocolActor)target, new Integer(toTransfer), new Integer(tpI.getLoad()) };
								Message message = new Message( self, source, "transferLoad", _arguments, null, token_5_0 );
								Object[] _propertyInfo = {  };
								message.setProperty( "priority", _propertyInfo );
								__messages.add( message );
							}
							// waitForSynch(token)
							{
								Object _arguments[] = { token_5_0 };
								Message message = new Message( self, self, "waitForSynch", _arguments, token_5_0, null );
								__messages.add( message );
							}
						}
					}
					i++;
					j--;
				}
			}
		}
		public void balanceTheatersCPU_Based() {
			if (theaterProfiles.size()!=0) {
				Vector profiles = new Vector();
				Iterator iterEntries = theaterProfiles.entrySet().iterator();
				totalCpu = 0;
				totalLoad = 0;
				while (iterEntries.hasNext()) {
					Map.Entry mapEntry = (Map.Entry)iterEntries.next();
					profiles.addElement((TheaterProfile)mapEntry.getValue());
					totalCpu += ((TheaterProfile)mapEntry.getValue()).getCpuUsage();
					totalLoad += ((TheaterProfile)mapEntry.getValue()).getLoad();
				}
				avgCpu = (int)(totalCpu/profiles.size());
				avgLoad = (int)(totalLoad/profiles.size());
				Collections.sort(profiles, new TheaterComparator_CpuBased());
				lightestTheater = ((TheaterProfile)profiles.firstElement()).getProtocolActor();
				TheaterProfile tp;
				System.out.println("------------------------------");
				for (Enumeration e = profiles.elements(); e.hasMoreElements(); ){
					tp = (TheaterProfile)e.nextElement();
					System.out.println(tp.getProtocolActor().getUAL().toString()+"\t"+tp.getCpuUsage()+" with "+tp.getLoad());
				}
				System.out.println("------------------------------\n");
				int size = profiles.size();
				int j = size-1;
				int i = 0;
				int loadDiff = 0;
				int total = 0;
				long cpuI, cpuJ;
				int loadI, loadJ;
				TheaterProfile tpI, tpJ;
				int toTransfer = 0;
				int loadThreshold;
				ActorReference target = null;
				ActorReference source = null;
				while (i<j) {
					tpI = (TheaterProfile)profiles.get(i);
					tpJ = (TheaterProfile)profiles.get(j);
					loadI = tpI.getLoad();
					loadJ = tpJ.getLoad();
					total = loadI+loadJ;
					cpuI = tpI.getCpuUsage();
					cpuJ = tpJ.getCpuUsage();
					loadThreshold = (int)((double)(cpuJ*total)/(double)(cpuI+cpuJ));
					if (loadI<loadThreshold&&Math.abs(loadI-loadJ)>2) {
						toTransfer = loadThreshold-loadI;
						if (toTransfer>5) toTransfer = 5;
						target = tpI.getProtocolActor();
						source = tpJ.getProtocolActor();
						{
							Token token_5_0 = new Token();
							// source<-transferLoad((PSLBProtocolActor)target, new Integer(toTransfer), new Integer(loadJ))
							{
								Object _arguments[] = { (PSLBProtocolActor)target, new Integer(toTransfer), new Integer(loadJ) };
								Message message = new Message( self, source, "transferLoad", _arguments, null, token_5_0 );
								Object[] _propertyInfo = {  };
								message.setProperty( "priority", _propertyInfo );
								__messages.add( message );
							}
							// waitForSynch(token)
							{
								Object _arguments[] = { token_5_0 };
								Message message = new Message( self, self, "waitForSynch", _arguments, token_5_0, null );
								__messages.add( message );
							}
						}
					}
					i++;
					j--;
				}
			}
		}
		public void releaseTheater(TheaterProfile tp) {
			if (tp==null) 			return;
			String key = tp.getMyUAL().toString();
			if (theaterProfiles.containsKey(key)) theaterProfiles.remove(tp.getMyUAL().toString());
		}
		public TheaterProfile getLightestTheater() {
			TheaterProfile lightTP = null;
			if (theaterProfiles.size()!=0) {
				Vector profiles = new Vector();
				Iterator iterEntries = theaterProfiles.entrySet().iterator();
				while (iterEntries.hasNext()) {
					Map.Entry mapEntry = (Map.Entry)iterEntries.next();
					profiles.addElement((TheaterProfile)mapEntry.getValue());
				}
				Collections.sort(profiles, new TheaterComparator_ActorBased());
				lightTP = (TheaterProfile)profiles.get(0);
			}
			return lightTP;
		}
		public TheaterProfile getHeaviestTheater() {
			TheaterProfile heavyTP = null;
			if (theaterProfiles.size()!=0) {
				Vector profiles = new Vector();
				Iterator iterEntries = theaterProfiles.entrySet().iterator();
				while (iterEntries.hasNext()) {
					Map.Entry mapEntry = (Map.Entry)iterEntries.next();
					profiles.addElement((TheaterProfile)mapEntry.getValue());
				}
				Collections.sort(profiles, new TheaterComparator_ActorBased());
				heavyTP = (TheaterProfile)profiles.firstElement();
			}
			return heavyTP;
		}
		public TheaterProfile getFastestTheater() {
			TheaterProfile fast = null;
			if (theaterProfiles.size()!=0) {
				Vector profiles = new Vector();
				Iterator iterEntries = theaterProfiles.entrySet().iterator();
				while (iterEntries.hasNext()) {
					Map.Entry mapEntry = (Map.Entry)iterEntries.next();
					profiles.addElement((TheaterProfile)mapEntry.getValue());
				}
				Collections.sort(profiles, new TheaterComparator_CpuBased());
				fast = (TheaterProfile)profiles.firstElement();
			}
			return fast;
		}
		public TheaterProfile getSlowestTheater() {
			TheaterProfile slow = null;
			if (theaterProfiles.size()!=0) {
				Vector profiles = new Vector();
				Iterator iterEntries = theaterProfiles.entrySet().iterator();
				while (iterEntries.hasNext()) {
					Map.Entry mapEntry = (Map.Entry)iterEntries.next();
					profiles.addElement((TheaterProfile)mapEntry.getValue());
				}
				Collections.sort(profiles, new TheaterComparator_CpuBased());
				slow = (TheaterProfile)profiles.lastElement();
			}
			return slow;
		}
		public void proceed() {
		}
	}
}