package ntsC2C.pslb;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;

import salsa.language.UniversalActor;

import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.

import java.util.*;
import ntsC2C.IOTheater;
import ntsC2C.peerserver.PeerServer;
import ntsC2C.peerserver.TheaterProfile;
import salsa.naming.*;
import salsa.language.*;

public class PSLBProtocolActor extends UniversalActor  {
	public static void main(String args[]) {
		UAN uan = null;
		UAL ual = null;
		if (System.getProperty("uan") != null) {
			uan = new UAN( System.getProperty("uan") );
			ServiceFactory.getTheater();
			RunTime.receivedUniversalActor();
		}
		if (System.getProperty("ual") != null) {
			ual = new UAL( System.getProperty("ual") );

			if (uan == null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an actor to have a ual at runtime without a uan.");
				System.err.println("	To give an actor a specific ual at runtime, use the identifier system property.");
				System.exit(0);
			}
			RunTime.receivedUniversalActor();
		}
		if (System.getProperty("identifier") != null) {
			if (ual != null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an identifier and a ual with system properties when creating an actor.");
				System.exit(0);
			}
			ual = new UAL( ServiceFactory.getTheater().getLocation() + System.getProperty("identifier"));
		}
		PSLBProtocolActor instance = (PSLBProtocolActor)new PSLBProtocolActor(uan, ual).construct();
		{
			Object[] _arguments = { args };
			instance.send( new Message(instance, instance, "act", _arguments, null, null) );
		}
	}

	public static ActorReference getReferenceByName(UAN uan)	{ return new PSLBProtocolActor(false, uan); }
	public static ActorReference getReferenceByName(String uan)	{ return PSLBProtocolActor.getReferenceByName(new UAN(uan)); }
	public static ActorReference getReferenceByLocation(UAL ual)	{ return new PSLBProtocolActor(false, ual); }

	public static ActorReference getReferenceByLocation(String ual)	{ return PSLBProtocolActor.getReferenceByLocation(new UAL(ual)); }
	public PSLBProtocolActor(boolean o, UAN __uan)	{ super(__uan); }
	public PSLBProtocolActor(boolean o, UAL __ual)	{ super(__ual); }

	public PSLBProtocolActor(UAN __uan)	{ this(__uan, null); }
	public PSLBProtocolActor(UAL __ual)	{ this(null, __ual); }
	public PSLBProtocolActor()		{ this(null, null);  }
	public PSLBProtocolActor(UAN __uan, UAL __ual) {
		if (__ual != null && !__ual.getLocation().equals(ServiceFactory.getTheater().getLocation())) {
			createRemotely(__uan, __ual, "ntsC2C.pslb.PSLBProtocolActor");
		} else {
			State state = new State(__uan, __ual);
			state.updateSelf(this);
			ServiceFactory.getNaming().setEntry(state.getUAN(), state.getUAL(), state);
			if (getUAN() != null) ServiceFactory.getNaming().update(state.getUAN(), state.getUAL());
		}
	}

	public UniversalActor construct () {
		Object[] __arguments = {  };
		this.send( new Message(this, this, "construct", __arguments, null, null) );
		return this;
	}

	public class State extends UniversalActor.State {
		public PSLBProtocolActor self;
		public void updateSelf(ActorReference actorReference) {
			self = (PSLBProtocolActor)actorReference;
			self.setUAN(getUAN());
			self.setUAL(getUAL());
		}

		public State() {
			this(null, null);
		}

		public State(UAN __uan, UAL __ual) {
			super(__uan, __ual);
			addClassName( "ntsC2C.pslb.PSLBProtocolActor$State" );
			addMethodsForClasses();
		}

		public void process(Message message) {
			Method[] matches = getMatches(message.getMethodName());
			Object returnValue = null;
			Exception exception = null;

			if (matches != null) {
				for (int i = 0; i < matches.length; i++) {
					try {
						if (matches[i].getParameterTypes().length != message.getArguments().length) continue;
						returnValue = matches[i].invoke(this, message.getArguments());
					} catch (Exception e) {
						if (e.getCause() instanceof CurrentContinuationException) {
							sendGeneratedMessages();
							return;
						} else if (e instanceof InvocationTargetException) {
							sendGeneratedMessages();
							exception = (Exception)e.getCause();
							break;
						} else {
							continue;
						}
					}
					sendGeneratedMessages();
					currentMessage.resolveContinuations(returnValue);
					return;
				}
			}

			System.err.println("Message processing exception:");
			if (message.getSource() != null) {
				System.err.println("\tSent by: " + message.getSource().toString());
			} else System.err.println("\tSent by: unknown");
			System.err.println("\tReceived by actor: " + toString());
			System.err.println("\tMessage: " + message.toString());
			if (exception == null) {
				if (matches == null) {
					System.err.println("\tNo methods with the same name found.");
					return;
				}
				System.err.println("\tDid not match any of the following: ");
				for (int i = 0; i < matches.length; i++) {
					System.err.print("\t\tMethod: " + matches[i].getName() + "( ");
					Class[] parTypes = matches[i].getParameterTypes();
					for (int j = 0; j < parTypes.length; j++) {
						System.err.print(parTypes[j].getName() + " ");
					}
					System.err.println(")");
				}
			} else {
				System.err.println("\tThrew exception: " + exception);
				exception.printStackTrace();
			}
		}

		Vector peerServers = new Vector();
		PSLBProfilingAgent profilingAgent = (PSLBProfilingAgent)IOTheater.getProfilingAgent();
		int sleepTime = 10000;
		long experimentStartTime = System.currentTimeMillis();
		long throughput = 0;
		void construct(){
			String connection = System.getProperty("connection");
			if (connection!=null) {
				try {
					UAL ual = new UAL(connection);
					if (ual.getIdentifier().equals("/io/peerServer")) 					{
						// joinComputation((PeerServer)PeerServer.getReferenceByLocation(ual))
						{
							Object _arguments[] = { (PeerServer)PeerServer.getReferenceByLocation(ual) };
							Message message = new Message( self, self, "joinComputation", _arguments, null, null );
							__messages.add( message );
						}
					}
					else {
						System.err.println("Improperly specified system property: "+connection);
						return;
					}
				}
				catch (MalformedUALException e) {
					System.err.println("Improperly specified system property: "+connection);
					System.err.println("Malformed UAL Exception: "+e);
					return;
				}

			}
		}
		public void begin(Integer index) {
			throughput = profilingAgent.processed();
			profilingAgent.reset();
			{
				// new Integer(index.intValue()+1)begin:((new Integer(sleepTime)))
				{
					Object _arguments[] = { new Integer(index.intValue()+1) };
					Message message = new Message( self, self, "begin", _arguments, null, null );
					Object[] _propertyInfo = { new Integer(sleepTime) };
					message.setProperty( "delay", _propertyInfo );
					__messages.add( message );
				}
			}
		}
		public void pauseFor(Long time) {
			try {
				Thread.sleep(time.longValue());
			}
			catch (InterruptedException e) {
				e.printStackTrace();
			}

		}
		public void joinComputation(PeerServer peerServer) {
			peerServers.add(peerServer);
			TheaterProfile myProfile = getRecentProfile();
			{
				// peerServer<-register(((PSLBProtocolActor)self), myProfile)
				{
					Object _arguments[] = { ((PSLBProtocolActor)self), myProfile };
					Message message = new Message( self, peerServer, "register", _arguments, null, null );
					__messages.add( message );
				}
			}
		}
		public Boolean transferLoad(PSLBProtocolActor destination, Integer numActors, Integer myLoad) {
			if (myLoad.intValue()!=profilingAgent.getLoad()) {
				return new Boolean(true);
			}
			ActorReference a = null;
			Vector candidates = profilingAgent.getCandidates(numActors.intValue());
			Token synchtoken = new Token( "synchtoken", new Object() );
			String targetUAL;
			{
				Token token_2_0 = new Token();
				// join block
				token_2_0.setJoinDirector();
				for (int i = 0; i<candidates.size(); i++){
					a = (ActorReference)candidates.get(i);
					targetUAL = "rmsp://"+destination.getUAL().getHost()+":"+destination.getUAL().getPort();
					if (a.getUAN().getIdentifier().startsWith("/")) targetUAL += a.getUAN().getIdentifier();
					else targetUAL += "/"+a.getUAN().getIdentifier();
					{
						// synchtoken = a<-migrate(new UAL(targetUAL))
						Token synchtoken_next = new Token("<-_next");
						{
							Object _arguments[] = { new UAL(targetUAL) };
							Message message = new Message( self, a, "migrate", _arguments, null, synchtoken_next );
							Object[] _propertyInfo = {  };
							message.setProperty( "priority", _propertyInfo );
							__messages.add( message );
						}
						synchtoken = synchtoken_next;
						// ()proceed:((synchtoken))
						{
							Object _arguments[] = {  };
							Message message = new Message( self, self, "proceed", _arguments, synchtoken_next, token_2_0 );
							Object[] _propertyInfo = { synchtoken };
							message.setProperty( "waitfor", _propertyInfo );
							__messages.add( message );
						}
					}
				}
				token_2_0.createJoinDirector();
				// proceed()
				{
					Object _arguments[] = {  };
					Message message = new Message( self, self, "proceed", _arguments, token_2_0, null );
					__messages.add( message );
				}
			}
			return new Boolean(true);
		}
		public void proceed() {
		}
		public void updatePeerServers() {
			for (int i = 0; i<peerServers.size(); i++)			{
				// ((PeerServer)peerServers.get(i))<-updateProfile(((PSLBProtocolActor)self), new Integer(profilingAgent.getLoad()), new Long(profilingAgent.getCpuUsage()), new Long(profilingAgent.getFreeMemory()), new Long(System.currentTimeMillis()))
				{
					Object _arguments[] = { ((PSLBProtocolActor)self), new Integer(profilingAgent.getLoad()), new Long(profilingAgent.getCpuUsage()), new Long(profilingAgent.getFreeMemory()), new Long(System.currentTimeMillis()) };
					Message message = new Message( self, ((PeerServer)peerServers.get(i)), "updateProfile", _arguments, null, null );
					__messages.add( message );
				}
			}
		}
		public void transferLoad(PSLBProtocolActor destination, Integer myLoad) {
			if (myLoad.intValue()!=profilingAgent.getLoad()) {
				return;
			}
synchronized (((PSLBProtocolActor)self)) {
{
				ActorReference ref = profilingAgent.getCandidate();
				{
					// migrateActor(ref, destination.getUAL())
					{
						Object _arguments[] = { ref, destination.getUAL() };
						Message message = new Message( self, self, "migrateActor", _arguments, null, currentMessage.getContinuationToken() );
						__messages.add( message );
					}
					throw new CurrentContinuationException();
				}
			}
}
		}
		public ActorReference getActor(String id) {
			if (id.startsWith("rmsp")) 			return UniversalActor.getReferenceByLocation(new UAL(id));
			else if (id.startsWith("uan")) 			return UniversalActor.getReferenceByName(new UAN(id));
			else 			return null;
		}
		public void migrateActor(ActorReference a, UAL destination) {
			if (a!=null) 			{
				// a<-migrate(new UAL(destination.getLocation()+a.getUAN().getIdentifier()))
				{
					Object _arguments[] = { new UAL(destination.getLocation()+a.getUAN().getIdentifier()) };
					Message message = new Message( self, a, "migrate", _arguments, null, null );
					Object[] _propertyInfo = {  };
					message.setProperty( "priority", _propertyInfo );
					__messages.add( message );
				}
			}
		}
		public TheaterProfile getRecentProfile() {
			TheaterProfile tp = new TheaterProfile(((PSLBProtocolActor)self));
			tp.setLoad(profilingAgent.getLoad());
			tp.setFreeMemory(profilingAgent.getFreeMemory());
			tp.setCpuUsage(profilingAgent.getCpuUsage());
			tp.setTag(System.currentTimeMillis());
			return tp;
		}
		public void leavePeerServer(PeerServer peerServer) {
			peerServers.remove(peerServer);
		}
		public String status() {
			String status = "";
			status += "\tTheater: "+getUAL().getLocation()+"\n";
			status += "\tTheater connected: "+profilingAgent.isComputing()+"\n";
			status += "\tTotal messages processed: "+profilingAgent.totalProcessed()+"\n";
			status += "\tProcessed since last reset: "+profilingAgent.processed()+"\n";
			status += "\tNumber of autonomous actors: "+profilingAgent.getActorProfiles().size();
			return status;
		}
		public Long getThroughput() {
			return new Long(throughput);
		}
	}
}