package ntsP2P;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;

import salsa.language.UniversalActor;

import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.

import java.util.Vector;
import theater.IOTheater;
import ats.ATSDecisionActor;
import core.agents.ProfilingAgent;
import resources.PeerServer;

public class NTSProtocolActor extends UniversalActor  {
	public static void main(String args[]) {
		UAN uan = null;
		UAL ual = null;
		if (System.getProperty("uan") != null) {
			uan = new UAN( System.getProperty("uan") );
			ServiceFactory.getTheater();
			RunTime.receivedUniversalActor();
		}
		if (System.getProperty("ual") != null) {
			ual = new UAL( System.getProperty("ual") );

			if (uan == null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an actor to have a ual at runtime without a uan.");
				System.err.println("	To give an actor a specific ual at runtime, use the identifier system property.");
				System.exit(0);
			}
			RunTime.receivedUniversalActor();
		}
		if (System.getProperty("identifier") != null) {
			if (ual != null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an identifier and a ual with system properties when creating an actor.");
				System.exit(0);
			}
			ual = new UAL( ServiceFactory.getTheater().getLocation() + System.getProperty("identifier"));
		}
		NTSProtocolActor instance = (NTSProtocolActor)new NTSProtocolActor(uan, ual).construct();
		{
			Object[] _arguments = { args };
			instance.send( new Message(instance, instance, "act", _arguments, null, null) );
		}
	}

	public static ActorReference getReferenceByName(UAN uan)	{ return new NTSProtocolActor(false, uan); }
	public static ActorReference getReferenceByName(String uan)	{ return NTSProtocolActor.getReferenceByName(new UAN(uan)); }
	public static ActorReference getReferenceByLocation(UAL ual)	{ return new NTSProtocolActor(false, ual); }

	public static ActorReference getReferenceByLocation(String ual)	{ return NTSProtocolActor.getReferenceByLocation(new UAL(ual)); }
	public NTSProtocolActor(boolean o, UAN __uan)	{ super(__uan); }
	public NTSProtocolActor(boolean o, UAL __ual)	{ super(__ual); }

	public NTSProtocolActor(UAN __uan)	{ this(__uan, null); }
	public NTSProtocolActor(UAL __ual)	{ this(null, __ual); }
	public NTSProtocolActor()		{ this(null, null);  }
	public NTSProtocolActor(UAN __uan, UAL __ual) {
		if (__ual != null && !__ual.getLocation().equals(ServiceFactory.getTheater().getLocation())) {
			createRemotely(__uan, __ual, "ntsP2P.NTSProtocolActor");
		} else {
			State state = new State(__uan, __ual);
			state.updateSelf(this);
			ServiceFactory.getNaming().setEntry(state.getUAN(), state.getUAL(), state);
			if (getUAN() != null) ServiceFactory.getNaming().update(state.getUAN(), state.getUAL());
		}
	}

	public UniversalActor construct () {
		Object[] __arguments = {  };
		this.send( new Message(this, this, "construct", __arguments, null, null) );
		return this;
	}

	public class State extends UniversalActor.State {
		public NTSProtocolActor self;
		public void updateSelf(ActorReference actorReference) {
			self = (NTSProtocolActor)actorReference;
			self.setUAN(getUAN());
			self.setUAL(getUAL());
		}

		public State() {
			this(null, null);
		}

		public State(UAN __uan, UAL __ual) {
			super(__uan, __ual);
			addClassName( "ntsP2P.NTSProtocolActor$State" );
			addMethodsForClasses();
		}

		public void process(Message message) {
			Method[] matches = getMatches(message.getMethodName());
			Object returnValue = null;
			Exception exception = null;

			if (matches != null) {
				for (int i = 0; i < matches.length; i++) {
					try {
						if (matches[i].getParameterTypes().length != message.getArguments().length) continue;
						returnValue = matches[i].invoke(this, message.getArguments());
					} catch (Exception e) {
						if (e.getCause() instanceof CurrentContinuationException) {
							sendGeneratedMessages();
							return;
						} else if (e instanceof InvocationTargetException) {
							sendGeneratedMessages();
							exception = (Exception)e.getCause();
							break;
						} else {
							continue;
						}
					}
					sendGeneratedMessages();
					currentMessage.resolveContinuations(returnValue);
					return;
				}
			}

			System.err.println("Message processing exception:");
			if (message.getSource() != null) {
				System.err.println("\tSent by: " + message.getSource().toString());
			} else System.err.println("\tSent by: unknown");
			System.err.println("\tReceived by actor: " + toString());
			System.err.println("\tMessage: " + message.toString());
			if (exception == null) {
				if (matches == null) {
					System.err.println("\tNo methods with the same name found.");
					return;
				}
				System.err.println("\tDid not match any of the following: ");
				for (int i = 0; i < matches.length; i++) {
					System.err.print("\t\tMethod: " + matches[i].getName() + "( ");
					Class[] parTypes = matches[i].getParameterTypes();
					for (int j = 0; j < parTypes.length; j++) {
						System.err.print(parTypes[j].getName() + " ");
					}
					System.err.println(")");
				}
			} else {
				System.err.println("\tThrew exception: " + exception);
				exception.printStackTrace();
			}
		}

		NTSProfilingAgent profilingAgent = null;
		NTSDecisionActor ntsDecisionActor = null;
		boolean connected = true;
		Vector peerServers = new Vector();
		int maxTTL = 5;
		int maxPeers = 10;
		void construct(){
			profilingAgent = (NTSProfilingAgent)IOTheater.getProfilingAgent();
			ntsDecisionActor = (NTSDecisionActor)IOTheater.getDecisionActor();
			String connection = System.getProperty("connection");
			if (connection!=null) {
				try {
					UAL ual = new UAL(connection);
					if (ual.getIdentifier().equals("/io/peerServer")) {
						{
							// joinComputation((PeerServer)PeerServer.getReferenceByLocation(ual))
							{
								Object _arguments[] = { (PeerServer)PeerServer.getReferenceByLocation(ual) };
								Message message = new Message( self, self, "joinComputation", _arguments, null, null );
								__messages.add( message );
							}
						}
					}
					else {
						{
							// joinComputation((NTSProtocolActor)NTSProtocolActor.getReferenceByLocation(ual))
							{
								Object _arguments[] = { (NTSProtocolActor)NTSProtocolActor.getReferenceByLocation(ual) };
								Message message = new Message( self, self, "joinComputation", _arguments, null, null );
								__messages.add( message );
							}
						}
					}
				}
				catch (MalformedUALException e) {
					System.err.println("Improperly specified system property: "+connection);
					System.err.println("Malformed UAL Exception: "+e);
				}

			}
		}
		Vector localPeers = new Vector();
		Vector regionalPeers = new Vector();
		Vector nationalPeers = new Vector();
		Vector globalPeers = new Vector();
		protected ActorReference getPeer(int locality, ActorReference source) {
			ActorReference peer = null;
			Vector targetVector = null;
			if (locality==1) targetVector = localPeers;
			else if (locality==2) targetVector = regionalPeers;
			else if (locality==3) targetVector = nationalPeers;
			else if (locality==4) targetVector = globalPeers;
			else {
				System.err.println("NTSProtocolActor Error:");
				System.err.println("\tInproper locality for getPeer: "+locality);
				System.err.println("\tSteal from source: "+source);
				return null;
			}
			if (targetVector.size()==0||(targetVector.size()==1&&targetVector.contains(source))) 			return null;
			else {
				while (peer==null||source.equals(peer)) {
					int place = (int)(java.lang.Math.random()*targetVector.size());
					peer = (ActorReference)targetVector.get(place);
				}
			}
			return peer;
		}
		protected void addPeer(ActorReference peer) {
			if (peer.equals(((NTSProtocolActor)self))) 			return;
			if (!localPeers.contains(peer)&&!regionalPeers.contains(peer)&&!nationalPeers.contains(peer)&&!globalPeers.contains(peer)) {
				double latency = profilingAgent.getLatency(peer.getUAL().getHost());
				if (latency>250) globalPeers.add(peer);
				else if (100<latency&&latency<=250) nationalPeers.add(peer);
				else if (10<latency&&latency<=100) regionalPeers.add(peer);
				else if (latency<=10) localPeers.add(peer);
			}
		}
		int locality = 3;
		boolean stealing = false;
		protected void initiateSteal() {
			if (!stealing) {
				ActorReference peer = getPeer(locality, ((NTSProtocolActor)self));
				if (peer!=null) {
					{
						// peer<-steal(((NTSProtocolActor)self), new Double(profilingAgent.getAvailableProcessing()), new Integer(locality), new Integer(maxTTL))
						{
							Object _arguments[] = { ((NTSProtocolActor)self), new Double(profilingAgent.getAvailableProcessing()), new Integer(locality), new Integer(maxTTL) };
							Message message = new Message( self, peer, "steal", _arguments, null, null );
							__messages.add( message );
						}
					}
				}
				locality++;
				if (locality==4) locality = 3;
			}
		}
		public void steal(ActorReference source, double remoteProcessing, int locality, int timeToLive) {
			profilingAgent.gotStealFrom(source.getUAL().toString());
			timeToLive--;
			if (timeToLive>maxTTL) timeToLive = maxTTL;
			if (timeToLive<0) {
				{
					// source<-stealFinished()
					{
						Object _arguments[] = {  };
						Message message = new Message( self, source, "stealFinished", _arguments, null, null );
						__messages.add( message );
					}
				}
				return;
			}
			Token candidate = new Token("candidate");
			{
				// token candidate = ntsDecisionActor<-getBestCandidate(source.getUAL(), new Double(remoteProcessing), new Integer(locality))
				{
					Object _arguments[] = { source.getUAL(), new Double(remoteProcessing), new Integer(locality) };
					Message message = new Message( self, ntsDecisionActor, "getBestCandidate", _arguments, null, candidate );
					__messages.add( message );
				}
			}
			{
				// resolveSteal(candidate, source, new Double(remoteProcessing), new Integer(locality), new Integer(timeToLive))
				{
					Object _arguments[] = { candidate, source, new Double(remoteProcessing), new Integer(locality), new Integer(timeToLive) };
					Message message = new Message( self, self, "resolveSteal", _arguments, null, null );
					__messages.add( message );
				}
			}
		}
		public void resolveSteal(ActorReference candidate, ActorReference source, double remoteProcessing, int locality, int timeToLive) {
			if (candidate==null) {
				{
					// propagateSteal(source, new Double(remoteProcessing), new Integer(locality), new Integer(timeToLive))
					{
						Object _arguments[] = { source, new Double(remoteProcessing), new Integer(locality), new Integer(timeToLive) };
						Message message = new Message( self, self, "propagateSteal", _arguments, null, null );
						__messages.add( message );
					}
				}
			}
			else {
				{
					Token token_3_0 = new Token();
					// candidate<-migrate(new UAL(source.getUAL().getLocation()+candidate.getUAN().getIdentifier()))
					{
						Object _arguments[] = { new UAL(source.getUAL().getLocation()+candidate.getUAN().getIdentifier()) };
						Message message = new Message( self, candidate, "migrate", _arguments, null, token_3_0 );
						Object[] _propertyInfo = {  };
						message.setProperty( "priority", _propertyInfo );
						__messages.add( message );
					}
					// source<-stealFinished()
					{
						Object _arguments[] = {  };
						Message message = new Message( self, source, "stealFinished", _arguments, token_3_0, null );
						__messages.add( message );
					}
				}
			}
		}
		public void propagateSteal(ActorReference source, double processing, int locality, int timeToLive) {
			ActorReference peer = getPeer(locality, ((NTSProtocolActor)self));
			if (peer!=null) {
				{
					// peer<-steal(source, new Double(processing), new Integer(locality), new Integer(timeToLive))
					{
						Object _arguments[] = { source, new Double(processing), new Integer(locality), new Integer(timeToLive) };
						Message message = new Message( self, peer, "steal", _arguments, null, null );
						__messages.add( message );
					}
				}
			}
			else {
				{
					// source<-stealFinished()
					{
						Object _arguments[] = {  };
						Message message = new Message( self, source, "stealFinished", _arguments, null, null );
						__messages.add( message );
					}
				}
			}
		}
		public void stealFinished() {
			stealing = false;
		}
		public void joinComputation(PeerServer peerServer) {
			profilingAgent.setComputing(true);
			peerServers.add(peerServer);
			{
				// peerServer<-register(((NTSProtocolActor)self))
				{
					Object _arguments[] = { ((NTSProtocolActor)self) };
					Message message = new Message( self, peerServer, "register", _arguments, null, null );
					__messages.add( message );
				}
			}
			{
				Token token_2_0 = new Token();
				// peerServer<-getPeers(new Integer(maxPeers))
				{
					Object _arguments[] = { new Integer(maxPeers) };
					Message message = new Message( self, peerServer, "getPeers", _arguments, null, token_2_0 );
					__messages.add( message );
				}
				// addPeers(token)
				{
					Object _arguments[] = { token_2_0 };
					Message message = new Message( self, self, "addPeers", _arguments, token_2_0, null );
					__messages.add( message );
				}
			}
		}
		public void addPeers(Vector peers) {
			if (peers==null) 			return;
			for (int i = 0; i<peers.size(); i++)			{
				// addPeer(peers.get(i))
				{
					Object _arguments[] = { peers.get(i) };
					Message message = new Message( self, self, "addPeer", _arguments, null, null );
					__messages.add( message );
				}
			}
		}
		public void joinComputation(ActorReference peer) {
			profilingAgent.setComputing(true);
			{
				// addPeer(peer)
				{
					Object _arguments[] = { peer };
					Message message = new Message( self, self, "addPeer", _arguments, null, null );
					__messages.add( message );
				}
			}
		}
		Vector unmigratedActors = null;
		public void leaveComputation() {
			profilingAgent.setComputing(false);
			if (System.getProperty("silent")==null) System.err.println("leaving!");
			for (int i = 0; i<peerServers.size(); i++){
				PeerServer target = (PeerServer)peerServers.get(i);
				peerServers.remove(target);
				{
					// target<-remove(((NTSProtocolActor)self))
					{
						Object _arguments[] = { ((NTSProtocolActor)self) };
						Message message = new Message( self, target, "remove", _arguments, null, null );
						__messages.add( message );
					}
				}
			}
			unmigratedActors = profilingAgent.getActorReferences();
			if (localPeers.size()==0&&regionalPeers.size()==0&&nationalPeers.size()==0&&globalPeers.size()==0) 			{
				// purge()
				{
					Object _arguments[] = {  };
					Message message = new Message( self, self, "purge", _arguments, null, null );
					__messages.add( message );
				}
			}
			else {
				for (int i = 0; i<localPeers.size(); i++){
					ActorReference target = (ActorReference)localPeers.get(i);
					{
						// target<-leaveRequest(((NTSProtocolActor)self))
						{
							Object _arguments[] = { ((NTSProtocolActor)self) };
							Message message = new Message( self, target, "leaveRequest", _arguments, null, null );
							__messages.add( message );
						}
					}
				}
				for (int i = 0; i<regionalPeers.size(); i++){
					ActorReference target = (ActorReference)regionalPeers.get(i);
					{
						// target<-leaveRequest(((NTSProtocolActor)self))
						{
							Object _arguments[] = { ((NTSProtocolActor)self) };
							Message message = new Message( self, target, "leaveRequest", _arguments, null, null );
							__messages.add( message );
						}
					}
				}
				for (int i = 0; i<nationalPeers.size(); i++){
					ActorReference target = (ActorReference)nationalPeers.get(i);
					{
						// target<-leaveRequest(((NTSProtocolActor)self))
						{
							Object _arguments[] = { ((NTSProtocolActor)self) };
							Message message = new Message( self, target, "leaveRequest", _arguments, null, null );
							__messages.add( message );
						}
					}
				}
				for (int i = 0; i<globalPeers.size(); i++){
					ActorReference target = (ActorReference)globalPeers.get(i);
					{
						// target<-leaveRequest(((NTSProtocolActor)self))
						{
							Object _arguments[] = { ((NTSProtocolActor)self) };
							Message message = new Message( self, target, "leaveRequest", _arguments, null, null );
							__messages.add( message );
						}
					}
				}
			}
		}
		public void leaveRequest(ActorReference requester) {
			localPeers.remove(requester);
			regionalPeers.remove(requester);
			nationalPeers.remove(requester);
			globalPeers.remove(requester);
			if (profilingAgent.isComputing()) 			{
				// requester<-getActor(((NTSProtocolActor)self))
				{
					Object _arguments[] = { ((NTSProtocolActor)self) };
					Message message = new Message( self, requester, "getActor", _arguments, null, null );
					__messages.add( message );
				}
			}
			else 			{
				// requester<-notConnected(((NTSProtocolActor)self))
				{
					Object _arguments[] = { ((NTSProtocolActor)self) };
					Message message = new Message( self, requester, "notConnected", _arguments, null, null );
					__messages.add( message );
				}
			}
		}
		public void notConnected(ActorReference peer) {
			localPeers.remove(peer);
			regionalPeers.remove(peer);
			nationalPeers.remove(peer);
			globalPeers.remove(peer);
			if (localPeers.size()==0&&regionalPeers.size()==0&&nationalPeers.size()==0&&globalPeers.size()==0) 			{
				// purge()
				{
					Object _arguments[] = {  };
					Message message = new Message( self, self, "purge", _arguments, null, null );
					__messages.add( message );
				}
			}
		}
		public void getActor(ActorReference requester) {
			if (unmigratedActors.size()>0) {
				ActorReference target = (ActorReference)unmigratedActors.get(0);
				unmigratedActors.remove(0);
				{
					// target<-migrate(requester.getUAL().getLocation()+target.getUAN().getIdentifier())
					{
						Object _arguments[] = { requester.getUAL().getLocation()+target.getUAN().getIdentifier() };
						Message message = new Message( self, target, "migrate", _arguments, null, null );
						Object[] _propertyInfo = {  };
						message.setProperty( "priority", _propertyInfo );
						__messages.add( message );
					}
				}
				if (unmigratedActors.size()>0) 				{
					// requester<-leaveRequest(((NTSProtocolActor)self))
					{
						Object _arguments[] = { ((NTSProtocolActor)self) };
						Message message = new Message( self, requester, "leaveRequest", _arguments, null, null );
						__messages.add( message );
					}
				}
			}
		}
		public void purge() {
			if (System.getProperty("silent")==null) System.err.println("purging!");
			Vector actors = profilingAgent.getActorReferences();
			for (int i = 0; i<actors.size(); i++){
				ActorReference target = (ActorReference)actors.get(i);
				{
					// target<-destroy()
					{
						Object _arguments[] = {  };
						Message message = new Message( self, target, "destroy", _arguments, null, null );
						Object[] _propertyInfo = {  };
						message.setProperty( "priority", _propertyInfo );
						__messages.add( message );
					}
				}
			}
		}
		public String status() {
			String status = "";
			status += "\tTheater: "+getUAL().getLocation()+"\n";
			status += "\tTheater connected: "+profilingAgent.isComputing()+"\n";
			status += "\tTotal messages processed: "+profilingAgent.totalProcessed()+"\n";
			status += "\tProcessed since last reset: "+profilingAgent.processed()+"\n";
			status += "\tNumber of autonomous actors: "+profilingAgent.getActorProfiles().size();
			return status;
		}
	}
}