package resources;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;

import salsa.language.UniversalActor;

import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.


public class PeerServer extends UniversalActor  {
	public static void main(String args[]) {
		UAN uan = null;
		UAL ual = null;
		if (System.getProperty("uan") != null) {
			uan = new UAN( System.getProperty("uan") );
			ServiceFactory.getTheater();
			RunTime.receivedUniversalActor();
		}
		if (System.getProperty("ual") != null) {
			ual = new UAL( System.getProperty("ual") );

			if (uan == null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an actor to have a ual at runtime without a uan.");
				System.err.println("	To give an actor a specific ual at runtime, use the identifier system property.");
				System.exit(0);
			}
			RunTime.receivedUniversalActor();
		}
		if (System.getProperty("identifier") != null) {
			if (ual != null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an identifier and a ual with system properties when creating an actor.");
				System.exit(0);
			}
			ual = new UAL( ServiceFactory.getTheater().getLocation() + System.getProperty("identifier"));
		}
		PeerServer instance = (PeerServer)new PeerServer(uan, ual).construct();
		{
			Object[] _arguments = { args };
			instance.send( new Message(instance, instance, "act", _arguments, null, null) );
		}
	}

	public static ActorReference getReferenceByName(UAN uan)	{ return new PeerServer(false, uan); }
	public static ActorReference getReferenceByName(String uan)	{ return PeerServer.getReferenceByName(new UAN(uan)); }
	public static ActorReference getReferenceByLocation(UAL ual)	{ return new PeerServer(false, ual); }

	public static ActorReference getReferenceByLocation(String ual)	{ return PeerServer.getReferenceByLocation(new UAL(ual)); }
	public PeerServer(boolean o, UAN __uan)	{ super(__uan); }
	public PeerServer(boolean o, UAL __ual)	{ super(__ual); }

	public PeerServer(UAN __uan)	{ this(__uan, null); }
	public PeerServer(UAL __ual)	{ this(null, __ual); }
	public PeerServer()		{ this(null, null);  }
	public PeerServer(UAN __uan, UAL __ual) {
		if (__ual != null && !__ual.getLocation().equals(ServiceFactory.getTheater().getLocation())) {
			createRemotely(__uan, __ual, "resources.PeerServer");
		} else {
			State state = new State(__uan, __ual);
			state.updateSelf(this);
			ServiceFactory.getNaming().setEntry(state.getUAN(), state.getUAL(), state);
			if (getUAN() != null) ServiceFactory.getNaming().update(state.getUAN(), state.getUAL());
		}
	}

	public UniversalActor construct () {
		Object[] __arguments = {  };
		this.send( new Message(this, this, "construct", __arguments, null, null) );
		return this;
	}

	public class State extends UniversalActor.State {
		public PeerServer self;
		public void updateSelf(ActorReference actorReference) {
			self = (PeerServer)actorReference;
			self.setUAN(getUAN());
			self.setUAL(getUAL());
		}

		public State() {
			this(null, null);
		}

		public State(UAN __uan, UAL __ual) {
			super(__uan, __ual);
			addClassName( "resources.PeerServer$State" );
			addMethodsForClasses();
		}

		public void process(Message message) {
			Method[] matches = getMatches(message.getMethodName());
			Object returnValue = null;
			Exception exception = null;

			if (matches != null) {
				for (int i = 0; i < matches.length; i++) {
					try {
						if (matches[i].getParameterTypes().length != message.getArguments().length) continue;
						returnValue = matches[i].invoke(this, message.getArguments());
					} catch (Exception e) {
						if (e.getCause() instanceof CurrentContinuationException) {
							sendGeneratedMessages();
							return;
						} else if (e instanceof InvocationTargetException) {
							sendGeneratedMessages();
							exception = (Exception)e.getCause();
							break;
						} else {
							continue;
						}
					}
					sendGeneratedMessages();
					currentMessage.resolveContinuations(returnValue);
					return;
				}
			}

			System.err.println("Message processing exception:");
			if (message.getSource() != null) {
				System.err.println("\tSent by: " + message.getSource().toString());
			} else System.err.println("\tSent by: unknown");
			System.err.println("\tReceived by actor: " + toString());
			System.err.println("\tMessage: " + message.toString());
			if (exception == null) {
				if (matches == null) {
					System.err.println("\tNo methods with the same name found.");
					return;
				}
				System.err.println("\tDid not match any of the following: ");
				for (int i = 0; i < matches.length; i++) {
					System.err.print("\t\tMethod: " + matches[i].getName() + "( ");
					Class[] parTypes = matches[i].getParameterTypes();
					for (int j = 0; j < parTypes.length; j++) {
						System.err.print(parTypes[j].getName() + " ");
					}
					System.err.println(")");
				}
			} else {
				System.err.println("\tThrew exception: " + exception);
				exception.printStackTrace();
			}
		}

		Vector peers = new Vector();
		void construct(){
			salsa.language.RunTime.receivedUniversalActor();
		}
		public void act(String[] arguments) {
			{
				// standardOutput<-println("PeerServer listening at UAL: "+getUAL())
				{
					Object _arguments[] = { "PeerServer listening at UAL: "+getUAL() };
					Message message = new Message( self, standardOutput, "println", _arguments, null, null );
					__messages.add( message );
				}
			}
		}
		public void remove(ActorReference peer) {
			{
				// standardOutput<-println("\tRemoving from registry: "+peer.getUAL().toString())
				{
					Object _arguments[] = { "\tRemoving from registry: "+peer.getUAL().toString() };
					Message message = new Message( self, standardOutput, "println", _arguments, null, null );
					__messages.add( message );
				}
			}
			peers.remove(peer);
		}
		public void register(ActorReference peer) {
			{
				// standardOutput<-println("\tAdding to registry: "+peer.getUAL().toString())
				{
					Object _arguments[] = { "\tAdding to registry: "+peer.getUAL().toString() };
					Message message = new Message( self, standardOutput, "println", _arguments, null, null );
					__messages.add( message );
				}
			}
			if (!peers.contains(peer)) peers.add(peer);
		}
		public Vector getPeers(int maxPeers) {
			{
				// standardOutput<-println("\tReceived request for "+maxPeers+" actors.")
				{
					Object _arguments[] = { "\tReceived request for "+maxPeers+" actors." };
					Message message = new Message( self, standardOutput, "println", _arguments, null, null );
					__messages.add( message );
				}
			}
			if (peers.size()==0) 			return null;
			Vector peersToSend = new Vector();
			for (int i = 0; i<maxPeers; i++){
				peersToSend.add(peers.get((int)(java.lang.Math.random()*peers.size())));
			}
			return peers;
		}
		public String purgeAll() {
			{
				// standardOutput<-println("\tPurging the entire computation.")
				{
					Object _arguments[] = { "\tPurging the entire computation." };
					Message message = new Message( self, standardOutput, "println", _arguments, null, null );
					__messages.add( message );
				}
			}
			{
				Token token_2_0 = new Token();
				// join block
				token_2_0.setJoinDirector();
				if (peers.size()==0) 				return "No connected theaters.\n";
				for (int i = 0; i<peers.size(); i++){
					ActorReference target = (ActorReference)peers.get(i);
					{
						Token token_4_0 = new Token();
						// target<-purge()
						{
							Object _arguments[] = {  };
							Message message = new Message( self, target, "purge", _arguments, null, token_4_0 );
							__messages.add( message );
						}
						// standardOutput<-println("\t\tPurged: "+target.getUAL().toString())
						{
							Object _arguments[] = { "\t\tPurged: "+target.getUAL().toString() };
							Message message = new Message( self, standardOutput, "println", _arguments, token_4_0, token_2_0 );
							__messages.add( message );
						}
					}
				}
				token_2_0.createJoinDirector();
				// combine(token)
				{
					Object _arguments[] = { token_2_0 };
					Message message = new Message( self, self, "combine", _arguments, token_2_0, currentMessage.getContinuationToken() );
					__messages.add( message );
				}
				throw new CurrentContinuationException();
			}
		}
		public String statusAll() {
			{
				Token token_2_0 = new Token();
				// join block
				token_2_0.setJoinDirector();
				if (peers.size()==0) 				return "No connected theaters.\n";
				for (int i = 0; i<peers.size(); i++){
					ActorReference target = (ActorReference)peers.get(i);
					{
						// target<-status()
						{
							Object _arguments[] = {  };
							Message message = new Message( self, target, "status", _arguments, null, token_2_0 );
							__messages.add( message );
						}
					}
				}
				token_2_0.createJoinDirector();
				// combine(token)
				{
					Object _arguments[] = { token_2_0 };
					Message message = new Message( self, self, "combine", _arguments, token_2_0, currentMessage.getContinuationToken() );
					__messages.add( message );
				}
				throw new CurrentContinuationException();
			}
		}
		public String combine(Object[] results) {
			String statusAll = "";
			for (int i = 0; i<results.length; i++){
				statusAll += (String)results[i]+"\n\n";
			}
			return statusAll;
		}
	}
}