package resources;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;

import salsa.language.UniversalActor;

import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.


public class Purge extends UniversalActor  {
	public static void main(String args[]) {
		UAN uan = null;
		UAL ual = null;
		if (System.getProperty("uan") != null) {
			uan = new UAN( System.getProperty("uan") );
			ServiceFactory.getTheater();
			RunTime.receivedUniversalActor();
		}
		if (System.getProperty("ual") != null) {
			ual = new UAL( System.getProperty("ual") );

			if (uan == null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an actor to have a ual at runtime without a uan.");
				System.err.println("	To give an actor a specific ual at runtime, use the identifier system property.");
				System.exit(0);
			}
			RunTime.receivedUniversalActor();
		}
		if (System.getProperty("identifier") != null) {
			if (ual != null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an identifier and a ual with system properties when creating an actor.");
				System.exit(0);
			}
			ual = new UAL( ServiceFactory.getTheater().getLocation() + System.getProperty("identifier"));
		}
		Purge instance = (Purge)new Purge(uan, ual).construct();
		{
			Object[] _arguments = { args };
			instance.send( new Message(instance, instance, "act", _arguments, null, null) );
		}
	}

	public static ActorReference getReferenceByName(UAN uan)	{ return new Purge(false, uan); }
	public static ActorReference getReferenceByName(String uan)	{ return Purge.getReferenceByName(new UAN(uan)); }
	public static ActorReference getReferenceByLocation(UAL ual)	{ return new Purge(false, ual); }

	public static ActorReference getReferenceByLocation(String ual)	{ return Purge.getReferenceByLocation(new UAL(ual)); }
	public Purge(boolean o, UAN __uan)	{ super(__uan); }
	public Purge(boolean o, UAL __ual)	{ super(__ual); }

	public Purge(UAN __uan)	{ this(__uan, null); }
	public Purge(UAL __ual)	{ this(null, __ual); }
	public Purge()		{ this(null, null);  }
	public Purge(UAN __uan, UAL __ual) {
		if (__ual != null && !__ual.getLocation().equals(ServiceFactory.getTheater().getLocation())) {
			createRemotely(__uan, __ual, "resources.Purge");
		} else {
			State state = new State(__uan, __ual);
			state.updateSelf(this);
			ServiceFactory.getNaming().setEntry(state.getUAN(), state.getUAL(), state);
			if (getUAN() != null) ServiceFactory.getNaming().update(state.getUAN(), state.getUAL());
		}
	}

	public UniversalActor construct() {
		Object[] __arguments = { };
		this.send( new Message(this, this, "construct", __arguments, null, null) );
		return this;
	}

	public class State extends UniversalActor.State {
		public Purge self;
		public void updateSelf(ActorReference actorReference) {
			self = (Purge)actorReference;
			self.setUAN(getUAN());
			self.setUAL(getUAL());
		}

		public State() {
			this(null, null);
		}

		public State(UAN __uan, UAL __ual) {
			super(__uan, __ual);
			addClassName( "resources.Purge$State" );
			addMethodsForClasses();
		}

		public void construct() {}

		public void process(Message message) {
			Method[] matches = getMatches(message.getMethodName());
			Object returnValue = null;
			Exception exception = null;

			if (matches != null) {
				for (int i = 0; i < matches.length; i++) {
					try {
						if (matches[i].getParameterTypes().length != message.getArguments().length) continue;
						returnValue = matches[i].invoke(this, message.getArguments());
					} catch (Exception e) {
						if (e.getCause() instanceof CurrentContinuationException) {
							sendGeneratedMessages();
							return;
						} else if (e instanceof InvocationTargetException) {
							sendGeneratedMessages();
							exception = (Exception)e.getCause();
							break;
						} else {
							continue;
						}
					}
					sendGeneratedMessages();
					currentMessage.resolveContinuations(returnValue);
					return;
				}
			}

			System.err.println("Message processing exception:");
			if (message.getSource() != null) {
				System.err.println("\tSent by: " + message.getSource().toString());
			} else System.err.println("\tSent by: unknown");
			System.err.println("\tReceived by actor: " + toString());
			System.err.println("\tMessage: " + message.toString());
			if (exception == null) {
				if (matches == null) {
					System.err.println("\tNo methods with the same name found.");
					return;
				}
				System.err.println("\tDid not match any of the following: ");
				for (int i = 0; i < matches.length; i++) {
					System.err.print("\t\tMethod: " + matches[i].getName() + "( ");
					Class[] parTypes = matches[i].getParameterTypes();
					for (int j = 0; j < parTypes.length; j++) {
						System.err.print(parTypes[j].getName() + " ");
					}
					System.err.println(")");
				}
			} else {
				System.err.println("\tThrew exception: " + exception);
				exception.printStackTrace();
			}
		}

		public void act(String[] arguments) {
			if (arguments.length==0) {
				System.err.println("Usage: java io.resources.Purge <ProtocolActor UAL or PeerServer UAL>*");
			}
			{
				Token token_2_0 = new Token();
				Token token_2_1 = new Token();
				// join block
				token_2_0.setJoinDirector();
				for (int i = 0; i<arguments.length; i++){
					UAL ual = new UAL(arguments[i]);
					if (ual.getIdentifier().equals("/io/peerServer")) {
						{
							Token token_5_0 = new Token();
							// new UniversalActor(ual)<-purgeAll()
							{
								Object _arguments[] = {  };
								Message message = new Message( self, new UniversalActor(ual), "purgeAll", _arguments, null, token_5_0 );
								__messages.add( message );
							}
							// standardOutput<-println("Purged peer server: "+ual.toString())
							{
								Object _arguments[] = { "Purged peer server: "+ual.toString() };
								Message message = new Message( self, standardOutput, "println", _arguments, token_5_0, token_2_0 );
								__messages.add( message );
							}
						}
					}
					else if (ual.getIdentifier().equals("/io/protocolActor")) {
						{
							Token token_5_0 = new Token();
							// new UniversalActor(ual)<-purge()
							{
								Object _arguments[] = {  };
								Message message = new Message( self, new UniversalActor(ual), "purge", _arguments, null, token_5_0 );
								__messages.add( message );
							}
							// standardOutput<-println("Purged IO theater: "+ual.toString())
							{
								Object _arguments[] = { "Purged IO theater: "+ual.toString() };
								Message message = new Message( self, standardOutput, "println", _arguments, token_5_0, token_2_0 );
								__messages.add( message );
							}
						}
					}
					else {
						{
							// standardOutput<-println("Invalid ual: "+ual.toString())
							{
								Object _arguments[] = { "Invalid ual: "+ual.toString() };
								Message message = new Message( self, standardOutput, "println", _arguments, null, token_2_0 );
								__messages.add( message );
							}
						}
					}
				}
				token_2_0.createJoinDirector();
				// standardOutput<-println("Finished purging the theaters.")
				{
					Object _arguments[] = { "Finished purging the theaters." };
					Message message = new Message( self, standardOutput, "println", _arguments, token_2_0, token_2_1 );
					__messages.add( message );
				}
				// completed()
				{
					Object _arguments[] = {  };
					Message message = new Message( self, self, "completed", _arguments, token_2_1, null );
					__messages.add( message );
				}
			}
		}
		public void completed() {
			System.exit(0);
		}
	}
}