package testing;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;

import salsa.language.UniversalActor;

import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.

import java.util.Vector;
import java.io.*;

public class Collector extends UniversalActor  {
	public static void main(String args[]) {
		UAN uan = null;
		UAL ual = null;
		if (System.getProperty("uan") != null) {
			uan = new UAN( System.getProperty("uan") );
			ServiceFactory.getTheater();
			RunTime.receivedUniversalActor();
		}
		if (System.getProperty("ual") != null) {
			ual = new UAL( System.getProperty("ual") );

			if (uan == null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an actor to have a ual at runtime without a uan.");
				System.err.println("	To give an actor a specific ual at runtime, use the identifier system property.");
				System.exit(0);
			}
			RunTime.receivedUniversalActor();
		}
		if (System.getProperty("identifier") != null) {
			if (ual != null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an identifier and a ual with system properties when creating an actor.");
				System.exit(0);
			}
			ual = new UAL( ServiceFactory.getTheater().getLocation() + System.getProperty("identifier"));
		}
		Collector instance = (Collector)new Collector(uan, ual).construct();
		{
			Object[] _arguments = { args };
			instance.send( new Message(instance, instance, "act", _arguments, null, null) );
		}
	}

	public static ActorReference getReferenceByName(UAN uan)	{ return new Collector(false, uan); }
	public static ActorReference getReferenceByName(String uan)	{ return Collector.getReferenceByName(new UAN(uan)); }
	public static ActorReference getReferenceByLocation(UAL ual)	{ return new Collector(false, ual); }

	public static ActorReference getReferenceByLocation(String ual)	{ return Collector.getReferenceByLocation(new UAL(ual)); }
	public Collector(boolean o, UAN __uan)	{ super(__uan); }
	public Collector(boolean o, UAL __ual)	{ super(__ual); }

	public Collector(UAN __uan)	{ this(__uan, null); }
	public Collector(UAL __ual)	{ this(null, __ual); }
	public Collector()		{ this(null, null);  }
	public Collector(UAN __uan, UAL __ual) {
		if (__ual != null && !__ual.getLocation().equals(ServiceFactory.getTheater().getLocation())) {
			createRemotely(__uan, __ual, "testing.Collector");
		} else {
			State state = new State(__uan, __ual);
			state.updateSelf(this);
			ServiceFactory.getNaming().setEntry(state.getUAN(), state.getUAL(), state);
			if (getUAN() != null) ServiceFactory.getNaming().update(state.getUAN(), state.getUAL());
		}
	}

	public UniversalActor construct() {
		Object[] __arguments = { };
		this.send( new Message(this, this, "construct", __arguments, null, null) );
		return this;
	}

	public class State extends UniversalActor.State {
		public Collector self;
		public void updateSelf(ActorReference actorReference) {
			self = (Collector)actorReference;
			self.setUAN(getUAN());
			self.setUAL(getUAL());
		}

		public State() {
			this(null, null);
		}

		public State(UAN __uan, UAL __ual) {
			super(__uan, __ual);
			addClassName( "testing.Collector$State" );
			addMethodsForClasses();
		}

		public void construct() {}

		public void process(Message message) {
			Method[] matches = getMatches(message.getMethodName());
			Object returnValue = null;
			Exception exception = null;

			if (matches != null) {
				for (int i = 0; i < matches.length; i++) {
					try {
						if (matches[i].getParameterTypes().length != message.getArguments().length) continue;
						returnValue = matches[i].invoke(this, message.getArguments());
					} catch (Exception e) {
						if (e.getCause() instanceof CurrentContinuationException) {
							sendGeneratedMessages();
							return;
						} else if (e instanceof InvocationTargetException) {
							sendGeneratedMessages();
							exception = (Exception)e.getCause();
							break;
						} else {
							continue;
						}
					}
					sendGeneratedMessages();
					currentMessage.resolveContinuations(returnValue);
					return;
				}
			}

			System.err.println("Message processing exception:");
			if (message.getSource() != null) {
				System.err.println("\tSent by: " + message.getSource().toString());
			} else System.err.println("\tSent by: unknown");
			System.err.println("\tReceived by actor: " + toString());
			System.err.println("\tMessage: " + message.toString());
			if (exception == null) {
				if (matches == null) {
					System.err.println("\tNo methods with the same name found.");
					return;
				}
				System.err.println("\tDid not match any of the following: ");
				for (int i = 0; i < matches.length; i++) {
					System.err.print("\t\tMethod: " + matches[i].getName() + "( ");
					Class[] parTypes = matches[i].getParameterTypes();
					for (int j = 0; j < parTypes.length; j++) {
						System.err.print(parTypes[j].getName() + " ");
					}
					System.err.println(")");
				}
			} else {
				System.err.println("\tThrew exception: " + exception);
				exception.printStackTrace();
			}
		}

		Vector pActors = new Vector();
		String configFile = "config.txt";
		int sleepTime = 10000;
		long experimentStartTime = System.currentTimeMillis();
		public void act(String[] args) {
			UniversalActor protocolActor = null;
			try {
				BufferedReader reader = new BufferedReader(new FileReader(configFile));
				String theaterUAL = null;
				while ((theaterUAL=reader.readLine())!=null) {
					protocolActor = new UniversalActor(new UAL(theaterUAL));
					pActors.add(protocolActor);
				}
			}
			catch (FileNotFoundException e) {
				e.printStackTrace();
			}
			catch (Exception e) {
				e.printStackTrace();
			}

			{
				// collectResults()
				{
					Object _arguments[] = {  };
					Message message = new Message( self, self, "collectResults", _arguments, null, null );
					__messages.add( message );
				}
			}
		}
		public void collectResults() {
			{
				Token token_2_0 = new Token();
				Token token_2_1 = new Token();
				// join block
				token_2_0.setJoinDirector();
				for (int i = 0; i<pActors.size(); i++)				{
					// ((UniversalActor)pActors.get(i))<-getThroughput()
					{
						Object _arguments[] = {  };
						Message message = new Message( self, ((UniversalActor)pActors.get(i)), "getThroughput", _arguments, null, token_2_0 );
						__messages.add( message );
					}
				}
				token_2_0.createJoinDirector();
				// sumUp(token)
				{
					Object _arguments[] = { token_2_0 };
					Message message = new Message( self, self, "sumUp", _arguments, token_2_0, token_2_1 );
					__messages.add( message );
				}
				// displayResults(token)
				{
					Object _arguments[] = { token_2_1 };
					Message message = new Message( self, self, "displayResults", _arguments, token_2_1, null );
					__messages.add( message );
				}
			}
			{
				// ()collectResults:((new Integer(sleepTime)))
				{
					Object _arguments[] = {  };
					Message message = new Message( self, self, "collectResults", _arguments, null, null );
					Object[] _propertyInfo = { new Integer(sleepTime) };
					message.setProperty( "delay", _propertyInfo );
					__messages.add( message );
				}
			}
		}
		public Long sumUp(Object[] throughputValues) {
			long total = 0;
			for (int i = 0; i<throughputValues.length; i++){
				total += ((Long)throughputValues[i]).longValue();
			}
			return new Long(total);
		}
		public void displayResults(Long throughputValue) {
			System.out.println((System.currentTimeMillis()-experimentStartTime)/1000+"\t"+throughputValue.longValue());
		}
	}
}