package testing.reachability;

// Import declarations generated by the SALSA compiler, do not modify.
import java.io.IOException;
import java.util.Vector;

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;
import java.lang.reflect.InvocationTargetException;

import salsa.language.Actor;
import salsa.language.ActorReference;
import salsa.language.Message;
import salsa.language.RunTime;
import salsa.language.ServiceFactory;
import salsa.language.Token;
import salsa.language.exceptions.*;
import salsa.language.exceptions.CurrentContinuationException;

import salsa.language.UniversalActor;

import salsa.naming.UAN;
import salsa.naming.UAL;
import salsa.naming.MalformedUALException;
import salsa.naming.MalformedUANException;

// End SALSA compiler generated import delcarations.

import java.io.FileInputStream;
import java.util.Vector;
import java.util.StringTokenizer;
import ntsP2P.NTSProtocolActor;

public class Ring extends UniversalActor  {
	public static void main(String args[]) {
		UAN uan = null;
		UAL ual = null;
		if (System.getProperty("uan") != null) {
			uan = new UAN( System.getProperty("uan") );
			ServiceFactory.getTheater();
			RunTime.receivedUniversalActor();
		}
		if (System.getProperty("ual") != null) {
			ual = new UAL( System.getProperty("ual") );

			if (uan == null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an actor to have a ual at runtime without a uan.");
				System.err.println("	To give an actor a specific ual at runtime, use the identifier system property.");
				System.exit(0);
			}
			RunTime.receivedUniversalActor();
		}
		if (System.getProperty("identifier") != null) {
			if (ual != null) {
				System.err.println("Actor Creation Error:");
				System.err.println("	uan: " + uan);
				System.err.println("	ual: " + ual);
				System.err.println("	Identifier: " + System.getProperty("identifier"));
				System.err.println("	Cannot specify an identifier and a ual with system properties when creating an actor.");
				System.exit(0);
			}
			ual = new UAL( ServiceFactory.getTheater().getLocation() + System.getProperty("identifier"));
		}
		Ring instance = (Ring)new Ring(uan, ual).construct();
		{
			Object[] _arguments = { args };
			instance.send( new Message(instance, instance, "act", _arguments, null, null) );
		}
	}

	public static ActorReference getReferenceByName(UAN uan)	{ return new Ring(false, uan); }
	public static ActorReference getReferenceByName(String uan)	{ return Ring.getReferenceByName(new UAN(uan)); }
	public static ActorReference getReferenceByLocation(UAL ual)	{ return new Ring(false, ual); }

	public static ActorReference getReferenceByLocation(String ual)	{ return Ring.getReferenceByLocation(new UAL(ual)); }
	public Ring(boolean o, UAN __uan)	{ super(__uan); }
	public Ring(boolean o, UAL __ual)	{ super(__ual); }

	public Ring(UAN __uan)	{ this(__uan, null); }
	public Ring(UAL __ual)	{ this(null, __ual); }
	public Ring()		{ this(null, null);  }
	public Ring(UAN __uan, UAL __ual) {
		if (__ual != null && !__ual.getLocation().equals(ServiceFactory.getTheater().getLocation())) {
			createRemotely(__uan, __ual, "testing.reachability.Ring");
		} else {
			State state = new State(__uan, __ual);
			state.updateSelf(this);
			ServiceFactory.getNaming().setEntry(state.getUAN(), state.getUAL(), state);
			if (getUAN() != null) ServiceFactory.getNaming().update(state.getUAN(), state.getUAL());
		}
	}

	public UniversalActor construct() {
		Object[] __arguments = { };
		this.send( new Message(this, this, "construct", __arguments, null, null) );
		return this;
	}

	public class State extends UniversalActor.State {
		public Ring self;
		public void updateSelf(ActorReference actorReference) {
			self = (Ring)actorReference;
			self.setUAN(getUAN());
			self.setUAL(getUAL());
		}

		public State() {
			this(null, null);
		}

		public State(UAN __uan, UAL __ual) {
			super(__uan, __ual);
			addClassName( "testing.reachability.Ring$State" );
			addMethodsForClasses();
		}

		public void construct() {}

		public void process(Message message) {
			Method[] matches = getMatches(message.getMethodName());
			Object returnValue = null;
			Exception exception = null;

			if (matches != null) {
				for (int i = 0; i < matches.length; i++) {
					try {
						if (matches[i].getParameterTypes().length != message.getArguments().length) continue;
						returnValue = matches[i].invoke(this, message.getArguments());
					} catch (Exception e) {
						if (e.getCause() instanceof CurrentContinuationException) {
							sendGeneratedMessages();
							return;
						} else if (e instanceof InvocationTargetException) {
							sendGeneratedMessages();
							exception = (Exception)e.getCause();
							break;
						} else {
							continue;
						}
					}
					sendGeneratedMessages();
					currentMessage.resolveContinuations(returnValue);
					return;
				}
			}

			System.err.println("Message processing exception:");
			if (message.getSource() != null) {
				System.err.println("\tSent by: " + message.getSource().toString());
			} else System.err.println("\tSent by: unknown");
			System.err.println("\tReceived by actor: " + toString());
			System.err.println("\tMessage: " + message.toString());
			if (exception == null) {
				if (matches == null) {
					System.err.println("\tNo methods with the same name found.");
					return;
				}
				System.err.println("\tDid not match any of the following: ");
				for (int i = 0; i < matches.length; i++) {
					System.err.print("\t\tMethod: " + matches[i].getName() + "( ");
					Class[] parTypes = matches[i].getParameterTypes();
					for (int j = 0; j < parTypes.length; j++) {
						System.err.print(parTypes[j].getName() + " ");
					}
					System.err.println(")");
				}
			} else {
				System.err.println("\tThrew exception: " + exception);
				exception.printStackTrace();
			}
		}

		int bi_connected = 0;
		Vector theaters = new Vector();
		public void act(String[] arguments) {
			try {
				if (arguments.length!=2) {
					this.errorMessage();
				}
				FileInputStream file;
				byte input[];
				try {
					file = new FileInputStream(arguments[0]);
					input = new byte[file.available()];
					file.read(input);
					StringTokenizer st = new StringTokenizer(new String(input), "\n");
					while (st.hasMoreTokens()) {
						theaters.add(st.nextToken());
					}
				}
				catch (Exception e) {
					System.err.println("Error reading naming/theater information file: "+e);
					System.exit(0);
				}

				bi_connected = new Integer(arguments[2]).intValue();
			}
			catch (Exception e) {
				this.errorMessage();
			}

			Token synchToken = new Token("synchToken");
			{
				// token synchToken = standardOutput<-println("Connecting the following theaters in a "+(bi_connected+1)+"-way tree.")
				{
					Object _arguments[] = { "Connecting the following theaters in a "+(bi_connected+1)+"-way tree." };
					Message message = new Message( self, standardOutput, "println", _arguments, null, synchToken );
					__messages.add( message );
				}
			}
			for (int i = 0; i<theaters.size(); i++){
				{
					// synchToken = standardOutput<-println("\t"+(String)theaters.get(i))
					Token synchToken_next = new Token("<-_next");
					{
						Object _arguments[] = { "\t"+(String)theaters.get(i) };
						Message message = new Message( self, standardOutput, "println", _arguments, null, synchToken_next );
						Object[] _propertyInfo = { synchToken };
						message.setProperty( "waitfor", _propertyInfo );
						__messages.add( message );
					}
					synchToken = synchToken_next;
				}
			}
			{
				Token token_2_1 = new Token();
				Token token_2_2 = new Token();
				// synchToken = standardOutput<-println()
				Token synchToken_next = new Token("<-_next");
				{
					Object _arguments[] = {  };
					Message message = new Message( self, standardOutput, "println", _arguments, null, synchToken_next );
					Object[] _propertyInfo = { synchToken };
					message.setProperty( "waitfor", _propertyInfo );
					__messages.add( message );
				}
				synchToken = synchToken_next;
				// standardOutput<-println("Generating links...")
				{
					Object _arguments[] = { "Generating links..." };
					Message message = new Message( self, standardOutput, "println", _arguments, synchToken_next, token_2_1 );
					__messages.add( message );
				}
				// join block
				token_2_2.setJoinDirector();
				for (int i = 0; i<theaters.size(); i++){
					String theaterName1 = (String)theaters.get(i);
					String theaterName2 = (String)theaters.get(i+1);
					NTSProtocolActor protocolActor1 = (NTSProtocolActor)NTSProtocolActor.getReferenceByLocation(theaterName1+"io/protocolActor");
					NTSProtocolActor protocolActor2 = (NTSProtocolActor)NTSProtocolActor.getReferenceByLocation(theaterName2+"io/protocolActor");
					{
						Token token_4_0 = new Token();
						// protocolActor1<-addPeer(protocolActor2)
						{
							Object _arguments[] = { protocolActor2 };
							Message message = new Message( self, protocolActor1, "addPeer", _arguments, token_2_1, token_4_0 );
							__messages.add( message );
						}
						// standardOutput<-println("\tGenerated link from "+theaterName1+" to "+theaterName2)
						{
							Object _arguments[] = { "\tGenerated link from "+theaterName1+" to "+theaterName2 };
							Message message = new Message( self, standardOutput, "println", _arguments, token_4_0, token_2_2 );
							__messages.add( message );
						}
					}
					if (bi_connected==1) {
						String theaterName3;
						if (i==0) theaterName3 = (String)theaters.get(theaters.size()-1);
						else theaterName3 = (String)theaters.get(i-1);
						NTSProtocolActor protocolActor3 = (NTSProtocolActor)NTSProtocolActor.getReferenceByLocation(theaterName3+"io/protocolActor");
						{
							Token token_5_0 = new Token();
							// protocolActor1<-addPeer(protocolActor3)
							{
								Object _arguments[] = { protocolActor3 };
								Message message = new Message( self, protocolActor1, "addPeer", _arguments, token_2_1, token_5_0 );
								__messages.add( message );
							}
							// standardOutput<-println("\tGenerated link from "+theaterName1+" to "+theaterName3)
							{
								Object _arguments[] = { "\tGenerated link from "+theaterName1+" to "+theaterName3 };
								Message message = new Message( self, standardOutput, "println", _arguments, token_5_0, token_2_2 );
								__messages.add( message );
							}
						}
					}
				}
				token_2_2.createJoinDirector();
				// standardOutput<-println("finished.")
				{
					Object _arguments[] = { "finished." };
					Message message = new Message( self, standardOutput, "println", _arguments, token_2_2, null );
					__messages.add( message );
				}
			}
		}
		public void errorMessage() {
			System.err.println("Usage: ");
			System.err.println("\tjava io.testing.reachability.Ring <theater information file> <0 for one way, 1 for two way>");
			System.exit(0);
		}
	}
}